2012-07-22  Aleksey Cheusov <vle@gmx.net>

  * NEWS, configure.in:
  Version -> 1.12.1
    dictl.in:
      Fix for Debian bug #677868 reported by Stepan Golosunov.

    dictd.8:
      Fixes for mistypes found by A. Costa. Thanks!

    dictzip:
      Fix for sf.net bug #3390567 reported by Ivo Danihelka.

    INSTALL:
      Fix for sf.net bug #3398178

    colorit:
      Fix for option -c. Now it works correctly.

    examples/dictd_virtual.conf:
      Fix incorrect keyword for virtual database.
        Thanks to Marc-Jano Knopp for the report!

  * colorit.in: fix in colorit: option -c now works correctly

  * dictzip.c:
  Check return value of fwrite, fflush and fclose functions.
  This fixes sf bug #3390567

  * dictl.in:
  Fix for Debian bug #677868 reported by Stepan Golosunov.

2012-02-13  Aleksey Cheusov <vle@gmx.net>

  * dictd.8.in: fixes for mistypes found by A. Costa. Thanks!

2011-10-22  Aleksey Cheusov <vle@gmx.net>

  * INSTALL: Fix for sf.net bug #3398178

2011-04-16  Aleksey Cheusov <vle@gmx.net>

  * examples/dictd_virtual.conf:
  fix in dictd_virtual.conf: incorrect keyword for virtual database.
     Thanks to Marc-Jano Knopp for the report!

2011-04-10  Aleksey Cheusov <vle@gmx.net>

  * Makefile.in: Add -c to ${INSTALL} envocations

2011-01-10  Aleksey Cheusov <vle@gmx.net>

  * Makefile.in: fix for installing from obj directory

2011-01-09  Aleksey Cheusov <vle@gmx.net>

  * NEWS, configure.in, dict_lookup, dict_lookup.1.in:
  new defaults for dict_lookup
  version -> 1.12.0

  * NEWS, dict_lookup.1.in: update for dict_lookup.1 and NEWS

  * Makefile.in, configure.in, dict_lookup:
  "install" and "install.dict" targets install dict_lookup script
     and its manual page.

  * dict_lookup.1.in: update

  * dict_lookup.1.in: initial version of manual page for dict_lookup

  * dictd.c: restore SA_RESTART

  * NEWS, dictd.c:
  restore SA_RESTART

  * NEWS: updates

  * NEWS, configure.in:
  version -> 1.11.3
  updates in NEWS

  * test/dictzip_test.in: remove dead code

2011-01-08  Aleksey Cheusov <vle@gmx.net>

  * daemon.c, dictd.c, dictd.h:
  SA_RESTART is not needed anymore. This unbreaks dictd on some platforms.
  Minor clean-ups.

  * data.c, dict.c, dictfmt.c, dictzip.c, index.c:
  Fixes for gcc warning messages seen on NetBSD-5.1/x86_64

  * daemon.c:
  fix for SHOW SERVER in dictd.
     On systems where sizeof(int) != sizeof (long)
     values in "Uncompressed" column may be contain random garbage.
     This problem was seen on NetBSD/x86_64/5.1

  * test/dictzip_test.in, Makefile.in, configure.in, data.c:
  Fix for sf bug #3098788
  https://sourceforge.net/tracker/?func=detail&aid=3098788&group_id=605&atid=100605

  Regresson tests for dictzip were added.

2011-01-05  Aleksey Cheusov <vle@gmx.net>

  * TODO: new search strategy

2011-01-03  Aleksey Cheusov <vle@gmx.net>

  * dict_lookup: support for option -h

2010-10-20  Aleksey Cheusov <vle@gmx.net>

  * dict_lookup:
  Further renamings.
  New var D_DICT_CMD was introduced

2010-10-19  Aleksey Cheusov <vle@gmx.net>

  * dict_lookup: spelling correction

  * dict_lookup: remove non-existant option -utf8 from xclip

  * dict_lookup: rename variables

  * dict_lookup: improvements, clean-ups

  * dict_lookup: introduce LESS_PROG

  * dict_lookup: coloritrc_dict -> dict

  * dict_lookup: Add options -h, -x, -y, -s and -q as well as new variables

2010-10-18  Aleksey Cheusov <vle@gmx.net>

  * dict_lookup: Yet another improvements

  * dict_lookup: lots of improvements and fixes

  * dict_lookup: lots of improvements

  * dict_lookup: Remove bashism; Fixes

  * dict_lookup: initial version of script by A.Vorontsov

  * dict_lookup: removed

  * dict_lookup: initial version of script by A.Vorontsov

2010-09-05  Aleksey Cheusov <vle@gmx.net>

  * net.c: remove #include <sys/termios.h>

  * dictd.c: fix for gcc warning message

2010-05-16  Aleksey Cheusov <vle@gmx.net>

  * TODO: new tasks

  * Makefile.in: fixed: compilation failure on Solaris (lex has no -o option)

2010-05-01  Aleksey Cheusov <vle@gmx.net>

  * dictfmt.c:
  Increase internal buffer size from 10240 to 102400 bytes.
  Minor clean-ups

  * str.c: +1 assert

2010-04-12  Aleksey Cheusov <vle@gmx.net>

  * test/dictd_test.in: fixes for Tru64

  * dictP.h:
  fixed: compilation failure on Tru64 (presense of getopt.h doesn`t mean presense of getopt_long(3))

  * configure.in: AC_FUNC_MALLOC is removed. This unbreaks dictd on Tru64.

2010-04-11  Aleksey Cheusov <vle@gmx.net>

  * dictd.c: get_entry_info: only NL is replaced with \0 (check for NL added)

2009-10-04  Aleksey Cheusov <vle@gmx.net>

  * NEWS, configure.in:
  Version -> 1.11.2
  NEWS update

2009-09-21  Aleksey Cheusov <vle@gmx.net>

  * test/dictd_test.in:
  update for regression tests for some type of sort(1) commands

  * test/db.expect.testdb_utf8.dict, test/db.expect.testdb_utf8.index:
  oops, I forgot to commit it

2009-09-20  Aleksey Cheusov <vle@gmx.net>

  * test/db.expect.smiley_1.index, test/db.expect.smiley_2.index, test/db.expect.smiley_3.index, test/db.expect.smiley_4.index, test/db.expect.smiley_5.index, test/dictd_smiley_2_res.expected.txt, test/dictd_smiley_4_res.expected.txt, test/dictd_smiley_5_res.expected.txt:
  updates for regression tests (sort -k1,1)

  * test/dictd_test.in: fix for building from outside OBJDIR

2009-09-19  Aleksey Cheusov <vle@gmx.net>

  * dictfmt.c:
  dictfmt spawns sort command to sort the index. When there are several
  entries for the same headword, they get sorted BY OFFSET AND SIZE (in
  addition to headwords), which don't sort alphabetically. As a result, the
  order of identical headwords is messed up.
  To fix these problem -k1,3 option is replaced with -k1,1.
  Thanks to Goran Tal for pointing out.

  * test/db.expect.cyrillic_1.index, test/db.expect.dict, test/db.expect.index, test/dictd_cyrillic_1_res.expected.txt, test/dictd_defstrat_1_res.expected.txt, test/dictd_test.in, test/testdb.c5.txt, test/testdb.e.txt, test/testdb.f.txt, test/testdb.h.txt, test/testdb.j.txt, test/testdb.p.txt, TODO, dictfmt.c:
  dictfmt: superfluous spaces are removed not only from the beginng and
     the end of a headword but also inside a multiword headwords.
     Thank to Goran Tal for pointing out.

  * dictfmt.1.in: FIX: s/--index-keep-headword/--index-keep-orig/

  * test/dictd_cyrillic_3_res.expected.txt, test/dictd_defstrat_1_res.expected.txt, test/dictd_defstrat_2_res.expected.txt, test/dictd_indexdata_1_res.expected.txt, test/dictd_limits_1_res.expected.txt, test/dictd_mixedcase_1_res.expected.txt, test/dictd_test.in:
  all test files are CR NL, just like dict protocol is

  * test/dictd_cyrillic_3_res.expected.txt, test/input.cyrillic_3.txt, index.c:
  FIX: When search is handled by dict_search_bmh() function, the first
     character from the first entry in the index file is missing. Usually
     this is some of 00-database-* entries.
     Thanks to Goran Tal for a bug report and patch.

     Add regression test for this case.

  * test/dictd_test.in: minor reorganization

2009-03-01  Aleksey Cheusov <vle@gmx.net>

  * configure.in: version -> 1.11.1

  * NEWS: Notes about upcoming release 1.11.1

  * INSTALL: updated for latest changes

  * Makefile.in: release unnecessary rule for dictd

2009-02-21  Aleksey Cheusov <vle@gmx.net>

  * configure.in, Makefile.in:
  LIBMAA variable added to Makefile, imported from ./configure

2009-01-31  Aleksey Cheusov <vle@gmx.net>

  * dictl.in:
  code clean-ups, significant simplification

2009-01-04  Aleksey Cheusov <vle@gmx.net>

  * dictfmt.c:
  FIXED: 'dictfmt -I' never worked (regrettable oversight, heh)
     Found and reported by Goran Tal <goran.tal@gmail.com>

  * daemon.c:
  SHOW STRAT: s/databases present/strategies present/
    Found and reported by Goran Tal <goran.tal@gmail.com>

2008-12-29  Aleksey Cheusov <vle@gmx.net>

  * Makefile.in: fix in uninstall target

  * configure.in:
  further clean-ups

  * Makefile.in, configure.in, dictP.h:
  remove checks for presense of memcpy and memmove. I don't care about
  platforms that do have them. I think all they are already dead.
  I you know such platforms, let me know
  Further clean-ups in configure.in and Makefile.in

  * configure.in, dictP.h:
  Further clean-ups. Remove checks for presense of unistd.h

  * Makefile.in, configure.in:
  (Clean-ups)
  Remove --with-local-libmaa, build libmaa before dictd/dict/... manually.
  This removes lots of garbage from configure.in and Makefile.in

  * configure.in:
  Enable additional gcc warnings on all platforms unconditionally.
  I need them under NetBSD

  * Makefile.in, configure.in:
  "building and installing different set of things based
  on configure results considered harmfull"(C)me :-)

  Plugins support in dictd is enabled by default (if available).
  DBI and JUDY plugins are disabled by default.
  This fixes sf.net bug #2218879

  * configure.in, include_regex.h.in, index.c:
  (Clean-ups) Ages ago, I've add to "configure" script an option
  --with-regex-include to make possible to build dictd with PCRE.
  Now, I've removed this option. If you want to build dictd with with PCRE,
  ask PCRE developers to install pcre/regex.h file linked to pcreposix.h.
  All other regexp libraries compatible with POSIX API do the same,
  rx/regex.h, rxspencer/regex.h etc. etc.
  So, this is good and well known convension.

  * Makefile.in:

  * configure.in: minor clean-ups

  * test/db.expect.hello_1.dict, test/db.expect.hello_2.dict, test/db.expect.hello_3.dict, test/db.expect.hello_4.dict, test/db.expect.hello_5.dict, test/db.expect.hello_5.index, test/db.expect.indexdata_1.dict, test/db.expect.mixedcase_1.dict, test/db.expect.smiley_1.dict, test/db.expect.smiley_2.dict, test/db.expect.smiley_3.dict, test/db.expect.smiley_4.dict, test/db.expect.smiley_5.dict, test/dictd_cyrillic_1_res.expected.txt, test/dictd_hello_1_res.expected.txt, test/dictd_hello_2_res.expected.txt, test/dictd_hello_3_res.expected.txt, test/dictd_hello_4_res.expected.txt, test/dictd_hello_5_res.expected.txt, test/dictd_smiley_2_res.expected.txt, test/dictd_smiley_4_res.expected.txt, test/dictd_smiley_5_res.expected.txt, test/db.expect.cyrillic_1.dict, test/db.expect.dict, dictfmt.c:
  fixed: sf.net bug #2197588 by Peter Volkov
     Now, all alphabet character from 00-database-alphabet special entry
     is resorted lexicographically and doesn;t depend on internal libmaa's
     function and sizeof(long)

2008-12-24  Aleksey Cheusov <vle@gmx.net>

  * dictl.in:
  Now dictl can use an external program for charset2charset conversion.
     Set DICTL_USE variable for this.
     I think this fixes sf.net bug #2407725

  * Makefile.in:
  clean-ups: DICT_DIR and CONF_DIR have no / at the end (like PLUGIN_DIR)

  * Makefile.in: fix for sf.net bug #2218879 (/ at the end of PLUGIN_DIR)

  * dictd.8.in: fixed: sf.net bug #2407717

  * Makefile.in: no Makefile.conf

  * Makefile.in: libmaa is not a part of dictd tarball

  * NEWS: tyop

  * NEWS:
  notes about release 1.11.0

  * Makefile.in: better ChangeLog

  * exclude_libmaa_logs: script for postprocessing rcs2log output

  * configure.in: "libmaa not found" error message

  * libmaa/maa.h, libmaa/maaP.h, Makefile.in: no $Id$ - I dislike it

  * Makefile.in: removed: -ldl from building dbi plugin

  * clientparse.y, clientscan.l, codes.h, daemon.c, data.c, dict.1.in, dict.h, dictP.h, dictd.8.in, dictd.c, dictd.h, dictfmt.c, dictzip.1.in, dictzip.c, dictzip.h, index.c, net.c, net.h, parse.c, parse.h, servparse.y, servscan.l:
  'Revised ...by ...' lines removed from sources, cvs know better when
     files were revised last time.
  my copyleft

  * Makefile.in:
  'dist' target renamed to 'cvsdist'
  minor fixes in clean/distclean/cvsclean targets

  * configure.in: version -> 1.11.0

  * daemon.c, data.c, dictP.h, dictd.c, dictdplugin_dbi.c, dictfmt.c, dictzip.c, index.c, lev.h, parse.c:
  fixed: gcc warnings, "unused variable" etc.

2008-11-15  Aleksey Cheusov <vle@gmx.net>

  * dict.c: fixed: gcc compilation warning

  * configure.in: Do not override CFLAGS set in environment. Never!

  * dictfmt_index2suffix.in:
  \001 -> \1 inside regexp. It seems it is better excepted
     by different awk/regexp_engines. (heirloom posix2001/awk and libuxre)

  * Makefile.in: fixes in "clean" target

  * test/dictd_test.in: fixed: ln -f -s ./file file
    This is fatal on Interix

  * configure.in, dictP.h: fix for Interix 3.5, socklen_t is defined in it

  * configure.in, dictP.h:
  fix for platforms having no getopt_long(3) (Solaris, HP-UX, Interix etc.)
     happens if --without-local-libmaa option is applied.

  * configure.in: checks for zlib.h iwhile configuring

  * configure.in: fix for previous commits

  * configure.in:
  REMOVED: --with-cflags, --with-prog, --with-gprof, --with-checker,
     --with-efence, --with-insure and --with-purify

      Use CFLAGS, LDFLAGS, CC etc. environment variables instead

  * configure.in:
  removed: home-made --with-cc. Use CC environment variable instead

  * configure.in: I hate $Id$, Grrr

  * configure.in:
  By default dictd is built with external libmaa library (if found).
     If it is not found, error message is output that suggests to apply
     --with-local-libmaa option.

2008-08-30  Aleksey Cheusov <vle@gmx.net>

  * dictfmt_index2suffix.in:
  GNU awk is not needed.

  * configure.in: previous commit reverted

  * configure.in: removed: $Revision: ...$

  * examples/dictd_popen.conf, examples/dictd_popen.conf.in, configure.in:
  fixed: sf.net bug #1627458

  * Makefile.in: rm ====> libtool --mode=uninstall

  * dictd.c:
  fixed: sf.net bug #1941358

2008-06-02  Aleksey Cheusov <vle@gmx.net>

  * Makefile.in: dictfmt_index2suffix/dictfmt_index2word are installed from ./

  * configure.in, dictfmt_index2suffix, dictfmt_index2suffix.in, dictfmt_index2word, dictfmt_index2word.in, test/dictd_test.in:
  dictfmt_index2suffix and dictfmt_index2word are generated from *.in

  * test/dictd_test.in: renamings

  * test/dictd_test.in: cyrillic_4 regression test restored

  * Makefile.in: rm -> rm -f in distclean target

  * Makefile.in, configure.in, test/dictd_test.in:
  'make test' now works fine from obj directory too
  cyrillic_4 test is temporarily disabled

2008-05-29  Aleksey Cheusov <vle@gmx.net>

  * Makefile.in: fix for dictd_test

  * Makefile.in: ./dictd_test -> $(srcdir)/dictd_test

  * examples/dictd_popen.conf, INSTALL, Makefile.in:
  fixes for sf.net bug #1627458

  * Makefile.in: date -> touch

2008-04-06  Aleksey Cheusov <vle@gmx.net>

  * NEWS, configure.in:
  version -> 1.10.11
  NEWS: Release notes

  * configure.in, daemon.c, dictdplugin_judy.c, dictfmt.c, index.c, iswalnum.c, iswspace.c, lev.h, plugin.c, plugins_common.c, strategy.c, strategy.h:
  fixed: lot of warning messages produced by icc-10 (Intel C Compiler)

2008-02-09  Aleksey Cheusov <vle@gmx.net>

  * dictd.c:
  timestamp message in log marker (log_option "timestamp")
      is changed to :t: from :T:
      because :T: begins client's full command (log_option "command")

2008-02-08  Aleksey Cheusov <vle@gmx.net>

  * colorit.in: bashism fixed: echo -en -> more portable printf

2008-01-31  Aleksey Cheusov <vle@gmx.net>

  * dict.c:
  ADDED: -F|--flush option for flushing stdout after each definition/match.
      It is useful in combination with -f
  'XXX definitions found' is printed with -f (revert previous changes)

  * dict.c, dictzip.c: copyright

  * dictfmt.c:
  FIXED: maximum length of headwords are limited to hardcoded constant
      just by cutting the end of headword.
      Now internal arrays are realloced automatically.

  * INSTALL: spelling error fixed

  * Makefile.in: -I. before -I${srcdir}

2008-01-27  Aleksey Cheusov <vle@gmx.net>

  * index.c:
  FIXED: while processing MATCH command unicity of only first column of
      .index is checked, but fourth column (if present) should also be
      checked.

2008-01-22  Aleksey Cheusov <vle@gmx.net>

  * dictP.h, dictd.c:
  FIXED: failure on Linux if --disable-plugin option is specified.
      Now USE_PLUGIN macros is checks correctly.

2008-01-20  Aleksey Cheusov <vle@gmx.net>

  * wcrtomb.c: fixed: warning generated by NetBSD/Alpha/GCC

2008-01-19  Aleksey Cheusov <vle@gmx.net>

  * configure.in, Makefile.in:
  CXX is detected using autoconf
  detection of AR/RANLIB is removed, they are not used directly
  libtool is run with --tag=CC and --tag=CXX for compiling C and C++ code
  C++ compiler cpp preprocessor are now detected using autoconf
  presence of fileno function is detected using autoconf
  removed: checking for command ar, not used directly

  * dict.c: removed: c99/c++ style comment markers

  * dictfmt.c, index.c, index.h, lev.h, wcrtomb.c:
  removed: c99/c++ style of comment markers

  * strategy.c: fixed: gcc warning

2008-01-12  Aleksey Cheusov <vle@gmx.net>

  * Makefile.in:
  'gmake install' now works fine even if dictd was configure from
      the external "object"(any!!!) directory. Some other autobloat-based
      projects can do the same.

  * Makefile.in:
  FIX: now dictd can be fully built from external "object" (any!) directory
      just like many other autobloat-based projects can

      That is, the following works fine now

        cd obj-dir
        /dir/to/dictd --with-libmaa
        gmake
        gmake install

  * configure.in: date ---> touch

2008-01-11  Aleksey Cheusov <vle@gmx.net>

  * clientscan.l, servscan.l:
  __FUNCTION__ -> __func__
      Now dictd is fully ready to compiled with pcc, tested under NetBSD

  * daemon.c: fix for pcc

  * dictd.c: fixed: pcc warning

  * daemon3.c, data.c, dict.c, dictd.c, dictzip.c, index.c, lev.h, libmaa/arg.c, libmaa/base26.c, libmaa/base64.c, libmaa/bit.c, libmaa/debug.c, libmaa/flags.c, libmaa/hash.c, libmaa/list.c, libmaa/log.c, libmaa/memory.c, libmaa/pr.c, libmaa/rnd.c, libmaa/set.c, libmaa/sl.c, libmaa/source.c, libmaa/string.c, libmaa/timer.c, libmaa/xmalloc.c, net.c, parse.c, plugin.c, snprintf.c, vsnprintf.c:
  Not standard __FUNCTION__ macros is changed to __func__
      All these changed sources can now be compiled with PCC (under NetBSD)
      PCC - Portable C Compiler

  * configure.in: inttypes.h header is checked

  * dictfmt.c: fixed: pcc warnings, __FUNCTION__ -> __func__

  * daemon.c: fixed: pcc warning

  * dictP.h: a few comments added

2007-12-26  Aleksey Cheusov <vle@gmx.net>

  * dictdplugin_popen.cpp:
  fixed: missed header file, seen with gcc-4.3.
      thanks to Martin Michlmayr for report

2007-11-10  Aleksey Cheusov <vle@gmx.net>

  * Makefile.conf: no autoreconf

  * NEWS: notes about release 1.10.10

  * configure.in:
  FIXED: ooooooold bug. configure script was run twice for libmaa
  version bumped to 1.10.10

  * dictl.in: fix for NetBSD where locale -k shows nothing

2007-10-10  Aleksey Cheusov <vle@gmx.net>

  * Makefile.in: minor fix in "clean" target

2007-09-29  Aleksey Cheusov <vle@gmx.net>

  * clientparse.y, clientscan.l, colorit.in, dict.1.in, dict.c, dict.h, dictl.1.in, dictl.in:
  DICT, DICTL and COLORIT programs DO NOT support option --pager|-P
      anymore. The code supporting this is removed.
      '-P -' is still allowed to not break the scripts.

      "Pager" functionality should be easily be implemented by users.
      See the following shell function.

         mydict () { dict "$@" 2>&1 | colorit | less; }

      Add it to you .profile (or whatever).

      I appologize for breaking backward compatibilities.

  * Makefile.in: minor fix in *clean targets

  * dictfmt.c: copyright

2007-07-27  Aleksey Cheusov <vle@gmx.net>

  * iswalnum.c:
  fix for utf-8 symbols other than BMP

2007-06-18  Aleksey Cheusov <vle@gmx.net>

  * test/dictd_test.in: fixed: dictfmt is not found

2007-05-29  Aleksey Cheusov <vle@gmx.net>

  * dictfmt_index2suffix: mawk sucks

  * test/testdb.cyrillic_1.conf, test/testdb.cyrillic_2.conf, test/testdb.cyrillic_4.conf, test/testdb.defstrat_1.conf, test/testdb.defstrat_2.conf, test/testdb.hello_1.conf, test/testdb.hello_2.conf, test/testdb.hello_3.conf, test/testdb.hello_4.conf, test/testdb.hello_5.conf, test/testdb.indexdata_1.conf, test/testdb.limits_1.conf, test/testdb.mixedcase_1.conf, test/testdb.smiley_1.conf, test/testdb.smiley_2.conf, test/testdb.smiley_3.conf, test/testdb.smiley_4.conf, test/testdb.smiley_5.conf:
  no limits in most tests

  * dictdplugin_dbi.c, dictdplugin_judy.c: compilation fixes

  * NEWS, configure.in: 1.10.9 release

  * daemon.c, dictd.8.in: limit_queries=0 means no limit

  * NEWS: notes about fix with getopt_long argument

  * NEWS: minor fixes

  * NEWS: notes about "limit_childs" keyword

  * defs.h, dictd.8.in, dictd.c, dictd.h, servparse.y, servscan.l:
  option/variable/macro renamings: limit -> limit_childs

  * NEWS, daemon.c, defs.h, dictd.8.in, dictd.c, dictd.h, servparse.y, servscan.l:
  ADDED: new keyword 'limit_queries' for limiting a number of queries
      that client may send to the server. It defaults to 2000.
  minor fixes in NEWS

  * dictfmt.c: better checking for required argument

  * NEWS: note about 1.10.9 release

  * dictfmt.1.in: minor fixes

  * dict.1.in: new words about -f

  * dict.1.in: minor fix

  * daemon.c, defs.h, dictd.8.in, dictd.c, dictd.h, servparse.y, servscan.l:
  ADDED: 'limit_time' option to 'global' dictd.conf section
     See dictd.8 for the more information.
  minor clean-ups: dict_daemon and dict_inetd function use global variable
     client_delay

2007-05-28  Aleksey Cheusov <vle@gmx.net>

  * test/dictd_cyrillic_3_res.expected.txt:    forgot to commit it

  * test/dictd_test.in, test/input.cyrillic_3.txt, test/testdb.cyrillic_2.conf, test/testdb.cyrillic_4.conf, configure.in:
  new self tests
  minor clean-ups

  * dictd.8.in, index.c, strategy.c, strategy.h:
  ADDED: Two new search strategies, 'first' and 'last'.
      See dictd.8 for the information.

  * dictd.c:
  I like empty lines to better separate code into sections ;-)

  * dictfmt_index2suffix, dictfmt_index2word:
  rewritten. Now they use dictfmt -i/-I for sorting
  fixes
  clean-ups

  * dictfmt.c:
  fix with -i and -I

  * dict.c:
  -f sends error messages like 'No matches...', 'No definitions...',
      'Invalid strategy...' etc. to stderr, not to the pager.

2007-05-27  Aleksey Cheusov <vle@gmx.net>

  * test/dictd_test.in, test/testdb.cyrillic_2.conf:
  commented test for dictfmt_index2word

  * dictfmt_index2word: fixes

  * dictfmt.c: -i and -I options fully support 4-column input

  * index.c: removed: unnecessary code for --test-xxx

2007-05-24  Aleksey Cheusov <vle@gmx.net>

  * dictfmt_index2word:
  almost completely rewriten

  * dictfmt.1.in, dictfmt.c:
  -i and -I have the following format:
      dictfmt -i|-I [options]

  * dictfmt.1.in, dictfmt.c:
  -i and -I twins are now fully implemented and documented.
      See dictfmt(1) form documentation

  * test/dictd_test.in: clean-ups

  * test/dictd_test.in: nothing

  * test/dictd_cyrillic_1_res.expected.txt, test/dictd_defstrat_2_res.expected.txt, test/dictd_hello_1_res.expected.txt, test/dictd_hello_2_res.expected.txt, test/dictd_hello_3_res.expected.txt, test/dictd_hello_4_res.expected.txt, test/dictd_hello_5_res.expected.txt, test/dictd_smiley_2_res.expected.txt, test/dictd_smiley_4_res.expected.txt, test/dictd_smiley_5_res.expected.txt, test/dictd_test.in:
  fixed: <CR> symbol at the end of line...

  * test/dictd_defstrat_2_res.expected.txt, test/dictd_test.in, test/input.defstrat_2.txt, test/testdb.defstrat_2.conf:
  another tiny test for default_strategy

  * test/dictd_defstrat_1_res.expected.txt, test/dictd_test.in, test/input.defstrat_1.txt, test/testdb.defstrat_1.conf:
  test for dictd/dictfmt --default-strategy

  * test/dictd_limits_1_res.expected.txt, test/dictd_test.in, test/input.limits_1.txt, test/testdb.limits_1.conf:
  small test for limi_matches

  * dictfmt.c, dictunformat.in:
  00-database-dictfmt-X.Y.Z headword is generated
      instead of 00-database-dictfmt

2007-05-23  Aleksey Cheusov <vle@gmx.net>

  * dictd.h, index.c, servparse.y, servscan.l, defs.h, dictd.8.in, dictd.c:
  ADDED: new keywords in "global" section. limit_matches and limit_defintions
      See dictd.8 for information

  * dictd.8.in: removed: docs about --test-* options

  * index.c:
  code clean-ups, added: dict_add_word_to_list function

  * dict.c, dictd.c, dictzip.c: I don't like $ in the code

  * dictd.c: copyright

  * dictd.c:
  The following option are removed:
     -t --test <word>
     --test-file <file>
     --ftest <file>
     --test-strategy <strategy>
     --test-db <database>
     --test-match
     --test-nooutput
     --test-idle
     --test-show-info <database>

    All these options were created for testing and debugging.
    Actually -i and newly created --stdin2stdout is anough
      (and better) for this.

  * dictd.8.in: minor improvement

2007-05-22  Aleksey Cheusov <vle@gmx.net>

  * daemon.c, dictd.8.in, dictd.c, dictd.h, servparse.y, servscan.l:
  ADDED: site_no_banner, site_no_uptime, site_no_dblist keyword to
     the configuration file ("global" options section).

     See dictd.8 for more information.

  * daemon.c, defs.h, dictd.8.in, dictd.c, dictd.h, examples/dictd4.conf, servparse.y:
  'site' keyword has ben moved to 'global' ection of configuration file
      'site' section is deprecated now, but is still supported,
      error messages is logged if it used. Documentation and examples/ are
      up-to-date

2007-05-19  Aleksey Cheusov <vle@gmx.net>

  * dict.1.in: documentation for an option -f

  * dict.c:
  -m support -f too.
     Matches have the following format <host><TAB><port><TAB><db><TAB><match>
  -D, -S, -I, -H, -i and similar also support -f (formatted output)

2007-05-13  Aleksey Cheusov <vle@gmx.net>

  * dict.c: new option -f partially implemented

2007-05-12  Aleksey Cheusov <vle@gmx.net>

  * dictunformat.in:
  Recently 4-column .index entries were introduced.
      Now dictunformat is ready for this kind of dictionaries
      and produces correct output.

  * test/dictd_test.in, dictfmt.1.in, dictfmt.c, dictunformat.in:
  added: dictfmt --without-ver option.
      See dictfmt.1 for more information

  * dictfmt.1.in:
  some docs for 00-database-mime-header entry
  minor fixes and changes

  * dictfmt.1.in: documentation for --case-sensitive option

  * dictfmt.1.in: documentation for --index-data-separator option

  * test/db.expect.indexdata_1.index, test/dictd_test.in, test/testdb.indexdata.txt:
  more complex test

  * dictfmt.c, test/db.expect.indexdata_1.dict, test/db.expect.indexdata_1.index, test/dictd_indexdata_1_res.expected.txt, test/dictd_test.in, test/input.indexdata_1.txt, test/testdb.indexdata.txt, test/testdb.indexdata_1.conf:
  added: tests --index-data-separator and --index-keep-orig dictfmt options
      and appropriate dictd search

  * dictfmt.c:
  ADDED: --dictfmt --index-data-separator option that allows
      to set index and data parts of the headword in .index file
      (first and fourth columns respectively) completely independantly.

      That is, the first column in .index file can now be treated
      as an index and an optional fourth columns - as a data, all this for
      MATCH protocol command.

  * codes.h, daemon.c, data.c, data.h, defs.h, dict.c, dict.h, dictP.h, dictd.c, dictdplugin_dbi.c, dictdplugin_judy.c, dictzip.c, heap.c, heap.h, index.c, index.h, lev.h, md5.c, net.c, net.h, parse.c, parse.h, plugin.c, plugin.h, plugins_common.c, plugins_common.h, servparse.y, servscan.l, str.c, str.h, strategy.c, strategy.h, clientparse.y, clientscan.l:
  removed: $Id$, I don't like it

  * dictfmt.c: no $Id$

  * dictfmt.c: code clean-ups

  * dictunformat.in:
  00-database-case-sensitive headword is also not output

  * defs.h, dictd.c, dictfmt.c, index.c, index.h, str.c, str.h, test/db.expect.mixedcase_1.dict, test/db.expect.mixedcase_1.index, test/dictd_mixedcase_1_res.expected.txt, test/dictd_test.in, test/input.mixedcase_1.txt, test/testdb.mixedcase.txt, test/testdb.mixedcase_1.conf:
  ADDED: support for case sensitive search.
      For this, database should be created using dictfmt --case-sensitive.

     In this case 00-database-case-sensitive headword is created which is
     checked by dictd

2007-05-06  Aleksey Cheusov <vle@gmx.net>

  * data.c, index.c, net.c: fixed: gcc4/NetBSD warning messages

2007-03-10  Aleksey Cheusov <vle@gmx.net>

  * Makefile.in: fix: tab should begin the first line of action, not spaces

2006-12-13  Aleksey Cheusov <vle@gmx.net>

  * NEWS: release notes for dictd-1.10.8

  * dictd.8.in: added: info about --stdin2stdout

  * configure.in: br

  * configure.in: no messages about flex/bison and GNU archive site

  * test/dictd_test, test/dictd_test.in, configure.in, dictunformat, dictunformat.in:
  fixes for Solaris:
      - awk version defaults to that detected by ./configure
      - fix for idiotic Solaris shell

  * Makefile.in, configure.in: libmaa: 0.990 -> 1.0; dict: 1.10.7 -> 1.10.8

2006-12-12  Aleksey Cheusov <vle@gmx.net>

  * dictd.c: added fcntl.h for open(2)

  * dictd.c: only 012 descriptors are closed and reopened while daemon(3)-izing

2006-12-11  Aleksey Cheusov <vle@gmx.net>

  * Makefile.in: fixes in install/uninstall targets

  * dictvd: del

  * Makefile.in, configure.in: fixes related to libtools and building xxxxFLAGS

  * Makefile.in: added: -lz

  * Makefile.in: libtool needs .lo, not .o

  * configure.in: no local zlib/regex/dmalloc anymore

  * configure.in: only CFLAGS, CPPFLAGS and LDFLAGS...

  * Makefile.in, configure.in:
  removed: WCFLAGS SCFLAGS XTRACFLAGS WLDFLAGS XTRALDFLAGS XTRAHEADERS
     Use CPPFLAGS, CFLAGS and LDFLAGS only!

  * index.c:
  altcompare removed
  malloc_count_while_searching -= 1

  * Makefile.in:
  -static removed from libtool arguments Makefile.in
  plugins are linked with LIBOBJS

  * Makefile.in:
  libtool-ization

  * configure.in:
  fixed: lex/yacc presense checking (non-portable "which /path/to/exe
  local_libmaa=0 by default

2006-12-09  Aleksey Cheusov <vle@gmx.net>

  * colorit.in: gensub(,...1) -> gsub()

2006-11-25  Aleksey Cheusov <vle@gmx.net>

  * index.c: fix for match nprefix/match exact/define

  * test/dictd_cyrillic_1_res.expected.txt, test/dictd_hello_1_res.expected.txt, test/dictd_hello_2_res.expected.txt, test/dictd_hello_3_res.expected.txt, test/dictd_hello_4_res.expected.txt, test/dictd_hello_5_res.expected.txt, test/dictd_smiley_2_res.expected.txt, test/dictd_smiley_4_res.expected.txt, test/dictd_smiley_5_res.expected.txt, test/dictd_test:
  to make a debug easier command itself is also logged

  * test/dictd_test: new temporary file

  * daemon.c, dictd.c, dictd.h:
  added: --stdin2stdout option for debugging purposes (in addition to -i)

2006-11-19  Aleksey Cheusov <vle@gmx.net>

  * dictd.8.in:
  Unknowledges section removed because neyther regex/ nor zlib/ are a part
     dictd distribution anymore
  Other minor clean-ups

2006-11-10  Aleksey Cheusov <vle@gmx.net>

  * test/dictd_test: better message is output in case of test failure

2006-09-19  Aleksey Cheusov <vle@gmx.net>

  * index.c:
  alcompare() function is implemented.
     Side effect: sf.net bug #1554437 is fixed.
     Side effect: for some sort of .index files MATCH command
      should work faster.
     TODO: remove malloc/free from altcompare.

2006-07-16  Aleksey Cheusov <vle@gmx.net>

  * NEWS, configure.in:
  updates for dictd-1.10.7
  a few fixed typos in NEWS

2006-07-14  Aleksey Cheusov <vle@gmx.net>

  * dictd.c:
  FIXED: nmap utility of just a client that aborts connection for any reason
     can cause dictd server to exit with error on NetBSD and probably
     other OSes. This is because accept(2) returns ECONNABORTED which
     is treated as a uncritical error on Linux-only and
     as a critical error on all other OSes.

     Affected versions: 1.4.9-1.10.6

2006-07-13  Aleksey Cheusov <vle@gmx.net>

  * dictd.c:
  fixed: `cat /var/run/dictd.pid` != pidof (dictd).
     Writing pid should happen after daemon(3)

2006-07-03  Aleksey Cheusov <vle@gmx.net>

  * NEWS: additions to 1.10.6 release

  * configure.in:
  removed: code that does not work with BSD 'which'
  1.10.5 ---> 1.10.6

  * dictd.c: removed: unnecessary code

2006-06-23  Aleksey Cheusov <vle@gmx.net>

  * test/dictd_test: nothing

  * test/dictd_cyrillic_1_res.expected.txt, test/dictd_test:
  Not only 'exact' search strategy is tested now.

  * index.c:
  fixed: 'word' strategy works incorrectly on OpenBSD and probably others
      because of incorrect isspacepuncttab array initizlization.

  * test/dictd_cyrillic_1_res.expected.txt, test/dictd_test:
  all search strategies are tested

  * test/dictd_cyrillic_1_res.expected.txt, test/dictd_hello_1_res.expected.txt, test/dictd_hello_2_res.expected.txt, test/dictd_hello_3_res.expected.txt, test/dictd_hello_4_res.expected.txt, test/dictd_hello_5_res.expected.txt, test/dictd_smiley_2_res.expected.txt, test/dictd_smiley_4_res.expected.txt, test/dictd_smiley_5_res.expected.txt, test/dictd_test:
  minor fixes

2006-06-22  Aleksey Cheusov <vle@gmx.net>

  * test/db.expect.cyrillic_1.dict, test/db.expect.cyrillic_1.index, test/dictd_cyrillic_1_res.expected.txt, test/dictd_hello_1_res.expected.txt, test/dictd_hello_2_res.expected.txt, test/dictd_hello_3_res.expected.txt, test/dictd_hello_4_res.expected.txt, test/dictd_hello_5_res.expected.txt, test/dictd_smiley_2_res.expected.txt, test/dictd_smiley_4_res.expected.txt, test/dictd_smiley_5_res.expected.txt, test/dictd_test, test/testdb.cyrillic.txt, test/testdb.cyrillic_1.conf:
  a few new tests, fixes, improvements

  * test/dictd_smiley_1_res.expected.txt, test/dictd_smiley_3_res.expected.txt, test/dictd_test:
  removed: too big files from testing

2006-05-27  Aleksey Cheusov <vle@gmx.net>

  * dictd.c, dictfmt.1.in, dictfmt.c, dictunformat, index.c, libmaa/base64.c, libmaa/maa.h:
  added: b64_decode_buf function to libmaa library
  index.c:dict_word_create: minor speed-ups, avoided use of malloc()
  dictfmt --index-keep-orig create (if necessary) fourth column
      in .index file that keeps original headword which is returned
      by MATCH command. See dictfmt.1 for details.
  dictd: If opening a pid file of log file failed, error messages are printed
      to stderr.

2006-05-26  Aleksey Cheusov <vle@gmx.net>

  * Makefile.in: make --> $(MAKE)

  * NEWS, configure.in: version --> 1.10.5

2006-05-19  Aleksey Cheusov <vle@gmx.net>

  * daemon3.c: new #includes added

2006-05-13  Aleksey Cheusov <vle@gmx.net>

  * daemon.c:
  FIXED: In case database_exit directive is used in dictd.conf
     SHOW DB command returns incorrect number of databases available.
     Afected versions: 1.10.2 -- 1.10.4

2006-05-06  Aleksey Cheusov <vle@gmx.net>

  * configure.in, daemon3.c, dictP.h, dictd.c, net.c:
  When available, system-wide daemon(3) function
      is used for becoming a daemon.

2006-04-15  Aleksey Cheusov <vle@gmx.net>

  * dictd.c:
  In dictd-1.9.14 dictd creates log file being root and than releases
     root priviledges. This was bad idea because log file may have % sign
     and may be used as a pattern for log files.

     Now older behaviour is restored, i.e.
     log file is created after releasing root priviledges.
     If you want to create log file under /var/log directory, create
     /var/log/dictd with appropriate permissions and create log files there.

     I apologize for inconvenience and breaking backward compatibility.

  * NEWS: typo fixed

2006-04-09  Aleksey Cheusov <vle@gmx.net>

  * libmaa/maaP.h, dictP.h: removed obsolete code

2006-04-08  Aleksey Cheusov <vle@gmx.net>

  * libmaa/Makefile.in, libmaa/decl.h, libmaa/maaP.h, libmaa/memtest.c, decl.h, deps, dictP.h, dictunformat:
  decl.h files seem obsolete to me. They cause problrems, do not help.

2005-12-12  Aleksey Cheusov <vle@gmx.net>

  * NEWS:
  new notes

  * NEWS:
  typo fixed

  * NEWS, configure.in, dictd.c, net.c:
  FIX: pid file was created with 0666 permissions

  * dictd.c:
  minor fixes by Kirk Hilliard

2005-12-08  Aleksey Cheusov <vle@gmx.net>

  * NEWS:
  Notes about regex/ and zlib/

  * configure.in, dictd.conf, examples/dictd1.conf:
  Version: 1.10.2 ---> 1.10.3
  Another example config file has been moved to examples/

  * NEWS:
  Notes about 1.10.3 release

  * config.guess, config.sub:
  updated

2005-12-06  Aleksey Cheusov <vle@gmx.net>

  * examples/dictd_complex.conf:
  fixes for m4 shipped with *BSD and Solaris that expands "index" to -1
      even if it is used without arguments.

  * examples/dictd4.conf, examples/dictd_virtual.conf: minor fixes

2005-12-05  Aleksey Cheusov <vle@gmx.net>

  * dict.c:
  fixed: compilation bugs (conformance to ANSI C)

  * dictP.h, libmaa/maaP.h:
  fixed: compilation bugs because of alloca

2005-12-03  Aleksey Cheusov <vle@gmx.net>

  * dictd.8.in, example.conf, example.dictrc, example.site, example2.conf, example3.conf, example_complex.conf, example_mime.conf, example_plugin_dbi.conf, example_popen.conf, example_virtual.conf, examples/dictd4.conf:
  Example files have been moved to examples/ directory
  A few references to these files from dictd.8

  * INSTALL, dictd.8.in, examples/dict1.conf, examples/dictd2.conf, examples/dictd3.conf, examples/dictd4.conf, examples/dictd_complex.conf, examples/dictd_mime.conf, examples/dictd_plugin_dbi.conf, examples/dictd_popen.conf, examples/dictd_site.txt, examples/dictd_virtual.conf:
  Example configuration files for 'dictd' and 'dict'
      have been moved to example/ directory

  * dictd.8.in:
  fixed: missing .RE

  * colorit.1.in, dict.1.in, dictd.8.in:
  minor changes in FILES section of man pages

  * Makefile.in, dictd.8.in, dictfmt_plugin, dictfmt_virtual, dictfmt_virtual.1:
  Files and directories in .1 and .8 are set according to ./configure options
  removed: dictfmt_virtual, dictfmt_plugin utilities.
      Configure plugin or virtual databases using dictd.conf file

  * colorit.1.in, configure.in, dict.1.in, dictd.8, dictd.8.in:
  File names (and optionally directories) in manual pages
       are specified according to ./configure options

  * dict.c:
  fixed (assert(3)):
     dict -M -S
     dict -M -D
     dict -M <query>

2005-11-30  Aleksey Cheusov <vle@gmx.net>

  * colorit.1, colorit.1.in, configure.in, dict.1, dict.1.in, dictfmt.1, dictfmt.1.in, dictfmt_index2suffix.1, dictfmt_index2suffix.1.in, dictfmt_index2word.1, dictfmt_index2word.1.in, dictl.1, dictl.1.in, dictunformat.1, dictunformat.1.in, dictzip.1, dictzip.1.in:
  renamed:
     dict.1  ---> dict.1.in
     dictd.8 ---> dictd.8.in
     ...
     in order to make absolute paths in man pages
     dependant on ./configure options

  * NEWS, dictd.8: minor fixes

2005-11-21  Aleksey Cheusov <vle@gmx.net>

  * dictd.c: noise exit after fatal error

  * Makefile.in: install -m 755 ====> mkdir -p

  * example.conf: fixed: missing space

2005-11-19  Aleksey Cheusov <vle@gmx.net>

  * dictd.8, index.c, index.h, strategy.c, strategy.h:
  ADDED: `nprefix' search strategy. See dictd.8 for more information.
      No plugin support yet.

2005-11-15  Aleksey Cheusov <vle@gmx.net>

  * test/testdb.hello_1.conf, test/testdb.hello_2.conf, test/testdb.hello_3.conf, test/testdb.hello_4.conf, test/testdb.hello_5.conf, test/testdb.smiley_1.conf, test/testdb.smiley_2.conf, test/testdb.smiley_3.conf, test/testdb.smiley_4.conf, test/testdb.smiley_5.conf:
  fixed: Some m4 shipped with Solaris/MacOS-/... translate index to -1
      when no arguments are specified. Solution: index ===> `index'

  * test/dictd_test: fix for Solaris-9: $PWD ===> `pwd`

2005-11-13  Aleksey Cheusov <vle@gmx.net>

  * dictP.h: fixed: defining __FUNCTION__

  * dictd.8: minor fix

2005-10-30  Aleksey Cheusov <vle@gmx.net>

  * test/dictd_smiley_2_res.expected.txt, test/dictd_smiley_3_res.expected.txt, test/dictd_smiley_4_res.expected.txt, test/dictd_smiley_5_res.expected.txt, test/dictd_hello_1_res.expected.txt, test/dictd_hello_2_res.expected.txt, test/dictd_hello_3_res.expected.txt, test/dictd_hello_4_res.expected.txt, test/dictd_hello_5_res.expected.txt, test/dictd_smiley_1_res.expected.txt, test/dictd_test, test/testdb.hello_1.conf, test/testdb.hello_2.conf, test/testdb.hello_3.conf, test/testdb.hello_4.conf, test/testdb.hello_5.conf, test/testdb.smiley_1.conf, test/testdb.smiley_2.conf, test/testdb.smiley_3.conf, test/testdb.smiley_4.conf, test/testdb.smiley_5.conf:
  lots of new tests for 'dictd'
  fixes, code clean-ups and improvements of tests for 'dictfmt'

  * daemon.c: fixes for inetd (daemonS_out ---> 1)

2005-10-15  Aleksey Cheusov <vle@gmx.net>

  * dict.c:
  minor fixes with pager, patches by Kirk Hilliard

  * dictfmt.1, dictl.1:
  fixed: sf.net bug #1227624, patches by micha137

  * dictl.in:
  fixed: sf.net bug #1223489, patches by micha137

  * test/dictd_test: minor fixes in printf

2005-09-22  Aleksey Cheusov <vle@gmx.net>

  * decl.h:
  fixed: compilation bug undet Solaris

  * configure.in, setenv.c:

  'setenv' function implementation (Solaris is affected)

2005-09-06  Aleksey Cheusov <vle@gmx.net>

  * NEWS: updated

  * NEWS: release time

  * NEWS, configure.in, dictd.8:
  documentation updated
  version: 1.10.1 --> 1.10.2

  * dictd.8:
  added: short description for a list of special headwords in .index file

  * NEWS: updates for 1.10.2

  * dictfmt.1:
  added: documentation for --utf8 option

  * NEWS: updated for 1.10.2

2005-09-05  Aleksey Cheusov <vle@gmx.net>

  * dictP.h, libmaa/maaP.h:
  fixed: compiler warnings on FreeBSD5

  * NEWS: *** empty log message ***

2005-09-02  Aleksey Cheusov <vle@gmx.net>

  * dictfmt.c, str.c:
  fixes for FreeBSD-4

2005-08-26  Aleksey Cheusov <vle@gmx.net>

  * colorit.in:
  new command implemented: gensub

2005-08-25  Aleksey Cheusov <vle@gmx.net>

  * Makefile.in:
  fixes in 'distclean' target

  * test/dictd_test:
  minor changes

  * dictfmt.c, test/db.expect.smiley_1.index:
  FIXED: dictfmt MUST produce the same output on all platforms.
     - -k 1,3 is used instead of -k 1,1, so all columns are used in sorting.
     - LC_ALL environment variable is ALWAYS set to C for 'sort' utility,
       otherwise sorting order depends on locale (LANG and LC_xxx variables).

2005-08-18  Aleksey Cheusov <vle@gmx.net>

  * test/db.expect.hello_1.dict, test/db.expect.hello_1.index, test/db.expect.hello_2.dict, test/db.expect.hello_2.index, test/db.expect.hello_3.dict, test/db.expect.hello_3.index, test/db.expect.hello_4.dict, test/db.expect.hello_4.index, test/db.expect.hello_5.dict, test/db.expect.hello_5.index, test/dictd_test, test/testdb.hello.txt:
  added: new tests for dictfmt

2005-08-17  Aleksey Cheusov <vle@gmx.net>

  * test/db.expect.smiley_1.dict, test/db.expect.smiley_1.index, test/db.expect.smiley_2.dict, test/db.expect.smiley_2.index, test/db.expect.smiley_3.dict, test/db.expect.smiley_3.index, test/db.expect.smiley_4.index, test/db.expect.smiley_5.dict, test/db.expect.smiley_5.index, test/dictd_test, test/testdb.smiley.txt, Makefile.in:
  more tests
  fixes, code-clean-ups

  * test/db.expect.dict, test/db.expect.index, test/db.expect.smiley_1.dict, test/db.expect.smiley_1.index, test/db.expect.smiley_2.dict, test/db.expect.smiley_2.index, test/db.expect.smiley_3.dict, test/db.expect.smiley_3.index, test/db.expect.smiley_4.dict, test/db.expect.smiley_4.index, test/dictd_test, test/testdb.c5.txt, test/testdb.e.txt, test/testdb.f.txt, test/testdb.h.txt, test/testdb.h.txt.dict, test/testdb.h.txt.index, test/testdb.j.txt, test/testdb.p.txt, test/testdb.smiley.txt:
  added: files for automatic testing, and testing script itself

2005-08-15  Aleksey Cheusov <vle@gmx.net>

  * NEWS, dictfmt.1:
  minor fixes

2005-08-14  Aleksey Cheusov <vle@gmx.net>

  * index.c:
  printf(...) --> PRINTF (DBG_SEARCH, (...))

  * dictfmt.c:
  fixed: 'dictfmt --allchars' run 'sort' utility with no C locale, while
      dictd requires this type of sorting.
      Affected versions: all dictfmt version providing --allchars option.
      It is strongly recommended to recreate dictionary
      which was built with --allchars option.

2005-08-13  Aleksey Cheusov <vle@gmx.net>

  * dictfmt.c:
  added: -i option

2005-07-26  Aleksey Cheusov <vle@gmx.net>

  * daemon.c:
  FIXED: 'SHOW DB' command shows the special entry '--exit--'
      as a normal database which cannot be used used for searching.
      This contradicts rfc-2229.

      Use 'SHOW SERVER' command to see where the default search stops.

  * dictfmt.c:
  FIXED: all these years dictfmt worked incorrectly
      because not only index part of .index was used in the sorting.
      A a result .index file could look like

        gawk:sample programs   CXyl    ON
        gawk:scalar constants  +sR     RS
        gawk:scanning an array BfKx    k7
    !   gawk   Se      I3e
        gawk:simple sed        Cpm/    xZ
        gawk:single character fields   pQy     So
        gawk:special caveats   7nN     Z2

    Pay attention to the line preceded by !.
    It leads to the word 'gawk' was never found.

    Now the external utility 'sort' is run with additional options:
      -t <TAB> -k 1,1

    Affected versions of dictfmt: 1.6.1 - 1.10.1

2005-07-20  Aleksey Cheusov <vle@gmx.net>

  * dictfmt.c:
  fixed: typo in error message

2005-07-17  Aleksey Cheusov <vle@gmx.net>

  * index.c:
  fixed: sometimes the regexp strategy may incorrectly
      because of optimization code and strange binary search.

      Thanks to Slava Kravchenko for bug report.
      Affected version: 1.4.9 - 1.10.1

2005-06-09  Aleksey Cheusov <vle@gmx.net>

  * NEWS: NEWS file update

  * NEWS, configure.in:
  news updated
  version --> 1.10.1

2005-06-08  Aleksey Cheusov <vle@gmx.net>

  * dictfmt.c:
  minor fix

  * index.c:
  By default 'dictd' is run in UTF-8 mode unless you ./configure it
     with --with-system-utf8-funcs option

  * dictfmt.c:
  added: --utf8 option. Use it to create utf-8 dictionaries.
      Use of '--locale ru_RU.UTF-8' is deprecated unless you
      ./configure dict packages with --with-system-utf8-funcs

  * dictP.h:
  MB_CUR_MAX__: 7 --> 6

  * dict.1:
  fixed: typo. Thanks to A Costa for reporting the bug report.

2005-04-14  Aleksey Cheusov <vle@gmx.net>

  * dictd.8, dictd.c, dictd.h, servparse.y, servscan.l:
  By default dictd, when running as daemon, writes a PID
      to /var/run/dictd.pid file. This can be overriden by
      'pid_file' keyword in dictd.conf (See dictd.8) of command line
      option '--pid-file'

      Thanks to Josef Novak for sudgestion and patch.

2005-04-13  Aleksey Cheusov <vle@gmx.net>

  * dictd.8:
  fixed: dictd.8 says that 'lev' strategy doesn't work
      with utf-8 dictionaries, but it does since release 1.9.13

  * configure.in, dictP.h, dictd.c, dictfmt.c, index.c, lev.h, mbrlen.c, mbrtowc.c, mbstowcs.c, mbtowc.c, str.c, wcrtomb.c, wctomb.c:
  unless 'dictd' is configured using './configure --with-system-utf8-funcs'
      'dictd' and 'dictfmt' use built-in UTF-8/UCS functions, i.e.
      there is no need for --locale xx_YY.UTF-8. As a result
      'dictd' can be compiled and run on platforms
      which doesn't have UTF-8 locale.

2005-04-12  Aleksey Cheusov <vle@gmx.net>

  * configure.in, NEWS:
  NEWS update (1.10.0 release)
  version: 1.9.15 ---> 1.10.0

  * example.conf:
  added: section containing global option

  * example_mime.conf:
  added: Yet another example demonstrating `database_mime' keyword

  * configure.in, dictP.h:
  fixed: compilation bugs on OpenBSD-3.4 which doesn't provide
      CODESET macro in <langinfo.h>

  * NEWS: nothing

  * dict.1, dictfmt.1:
  Documentation update

2005-04-09  Aleksey Cheusov <vle@gmx.net>

  * plugin.c, servparse.y:
  fixed: `default_strategy' keyword is not implemented
      for `database_plugin' section

2005-04-01  Aleksey Cheusov <vle@gmx.net>

  * daemon.c:
  fixed: database_mime + invisible

  * dictfmt.c:
  fix

2005-03-31  Aleksey Cheusov <vle@gmx.net>

  * INSTALL:
  minor changes

  * dictd.8:
  Documentation for `database_mime' section

  * dictfmt.c:
  The special headword 00-database-mime-header is never wrapped

  * example_plugin_dbi.conf:
  better explanation

2005-03-30  Aleksey Cheusov <vle@gmx.net>

  * index.c:
  indentation

  * servparse.y:
  nothing

  * dict.c:
  added: -M option to `dict' for sending OPTION MIME command to DICT server

2005-03-29  Aleksey Cheusov <vle@gmx.net>

  * dictunformat, servparse.y, dictfmt.c, defs.h, dictd.c, daemon.c:
  dictfmt, dictd:
     added new option --mime-header to `dictfmt'.  If
     applied, `dictfmt' creates the special headword
     00-database-mime-header, `dictd' read it while initializing the
     database and prepend definitions with it (if OPTION MIME command was
     sent by client). Ability to set the MIME header for the database is
     useful in combination with `database_mime' keyword in dictd.conf,
     See dictd.8 for more information.
  `dictunformat' skips 00-database-mime-header headword

  * index.c: nothing

  * defs.h, dictd.c, index.c, index.h, servparse.y, servscan.l, daemon.c:
  added: database_mime, dbname_nomime and dbname_mime keywords
      in dictd configuration file

      Example:

         database cool_db___nomime  {...}
         database cool_db___mime  {...}

         # The following section adds new database cool_db
         # When client acceses it and DOES send OPTION MIME command
         # to dictd it actually accesses the database `cool_db___mime'
         # otherwise (no MIME OPTION command was set)
         # the database `cool_db___nomime' is used.
         # This allows server to provide databases with support
         # of both plain text and formatted definitions
         # with appropriate MIME header (roff, html etc...)
         database_mime cool_db {
            dbname_mime   "cool_db___mime"
            dbname_nomime "cool_db___nomime"
         }

2005-03-28  Aleksey Cheusov <vle@gmx.net>

  * NEWS, dictd.8, dictd.c, dictd.h, servparse.y, servscan.l:
  ADDED: Global Setting section in dictd.conf
      Now configuration files can include all required option
      (command line option are no required anymore)

      dictd.conf may look like this

        global {
           port             2628
           delay            600
           depth            10
           limit            100
           timestamp        0

           log_option       "found"
           log_option       "notfound"
           log_option       "stats"
           log_option       "client"

           debug_option     "init"
           locale           ru_RU.UTF-8

           add_strategy     "phonetic" "Phonetic search"
           add_strategy     "reverse"  "Full text search in definitions"

        #   listen_to        127.0.0.1
        #   syslog
        #   syslog_facility daemon
           log_file         "/var/log/dictd.log"
        #   fast_start
        #   without_mmap
        }

2004-12-23  Aleksey Cheusov <vle@gmx.net>

  * NEWS: updates in NEWS

  * libmaa/Makefile.in, libmaa/arggram2c, libmaa/arggram2c.in, libmaa/configure.in, configure.in:
  changes necessary for Solaris which loves old awk
  1.9.14 --> 1.9.15

2004-12-13  Aleksey Cheusov <vle@gmx.net>

  * Makefile.in: man plugin removed

2004-11-25  Aleksey Cheusov <vle@gmx.net>

  * NEWS:
  added information about 1.9.15 release

2004-11-19  Aleksey Cheusov <vle@gmx.net>

  * dictd.8, dictfmt.c, dictunformat, index.c, defs.h:
  For 8-bit databases (non-ASCII and non-UTF8), `dictfmt' generates
     special headword 00-database-8bit-new
     (earlier versions generated 00-database-8bit)
  When `dictd' encounter `00-database-8bit' headword in .index file,
     it logs error message and exits

  * example2.conf:
  demonstration of new keyword `default_strategy'

  * dictfmt.c, index.c:
  Because of sorting order of 'sort -df' and `index.c:compare_alnumspace'
      differ, 8-bit (non-ASCII and non-UTF-8) databases are built
      using `sort' utility whithout options and with LC_ALL=C

      index.c is changed appropriately.

      NOTE!
      This makes `dictd' incompatible
      with 8-bit databases built using dictfmt older than 1.9.15!!!

2004-11-17  Aleksey Cheusov <vle@gmx.net>

  * libmaa/hash.c, libmaa/sl.c, libmaa/string.c, libmaa/arg.c, lev.h, plugins_common.c, plugins_common.h, strategy.c, strategy.h, dict.c, dictdplugin_judy.c, dictzip.c, index.c, daemon.c:
  fixed: a few warning messages produced by gcc

2004-11-07  Aleksey Cheusov <vle@gmx.net>

  * dictd.c, index.c:
  better logging

2004-10-12  Aleksey Cheusov <vle@gmx.net>

  * Makefile.in, defs.h, dictd.8, dictd.c, index.c, plugin.c, servparse.y, servscan.l:
  ADDED: `default_strategy' key word in configuration file.
      This allows to set default search strategy (`.') per database.
      See dictd.8 for more info
  Documentation update

  * daemon.c, dictd.c:
  FIXED: `dictd' dies when client tries to obtain information
      about virtual database (SHOW INFO <virt_db>).
  lots of `const' modifier in daemon.c
  added: --test-show-info option to `dictd'

  * daemon.c, data.c, dictd.c, index.c, plugin.c:
  DICT_EXACT --> DICT_STRAT_EXACT, etc.

  * dictfmt.1, dictfmt.c:
  added: --default-strategy option.
      Sets the default search strategy for the database.
      It will be used instead of strategy '.'.
      Special entry 00-database-default-strategy is created for this purpose.
      This option may be useful, for example,
      for dictionaries containing mainly phrases but the single words.
      In any case, use this option
      if you are absolutely sure what you are doing.
  dictfmt.1 update

  * strategy.c, strategy.h:
  added: functions `get_strategy', `lookup_strategy_ex'
  DICT_EXACT --> DICT_STRAT_EXACT, DICT_PREFIX --> DICT_STRAT_PREFIX etc.
  adde: new define DICT_STRAT_DOT for strategy `.'

  * index.c:
  fixed: The function `dict_search_bmh' works incorrectly in utf-8 mode
      on non-glibc systems, e.g. FreeBSD.
      As a result `suffix', `substring' and `word' work incorrectly
      with UTF-8 databases.

  * configure.in, dictP.h, dictd.c, iswalnum.c, iswspace.c, towlower.c:
  `_ALL_SOURCE' macros is define on Microsoft Interix in dictP.h file
  added: `iswalnum.c', `iswspace.c', `towlower.c' files to always
     support UTF-8 on platforms which do not provide mentioned functions
     (FreeBSD4.X / MS Interix)
  `wait3' is replaced for `waitpid' if it is unavailable (Interix)
  checks for the function `initgroups' which is unavailable on Interix
  `echo -en' is replaced for `printf' in configure.in
  `AC_FUNC_MMAP' is replaced for `AC_CHECK_FUNC(mmap)'
     because `mmap' work perfectly on Windows (Cygwin and Interix).
     `AC_FUNC_MMAP' implements too strict tests
     As a result `mmap' will be used in `dictd' if
     it is built on the latest versions of Cygwin or Interix
  `dictd' has been slightly tested on Interix (SFU-3.0).
     It seems it works perfectly both as Interix daemon and Windows service
     with ASCII databases in the following configurations:
     w2k workst/server + GNU make-3.76/3.80 + gcc-2.7.2.3/egcs-20000731 +
       yacc/bison

     NOTE: GNU make is needed for building `dictd'

  * getopt.c:
  fixed: compilation bug on Microsoft Interix.
      _ALL_SOURCE macro is defined if __INTERIX or __OPENNT are defined

  * net.c:
  `ioctl(fd, TIOCNOTTY, 0);' is not called on MS Interix/Cygwin/HP-UX
    if there is no macro `TIOCNOTTY'.
    As a result net.c can be compiled successfully on Interix

2004-10-05  Aleksey Cheusov <vle@gmx.net>

  * dictd.c:
  fix: logging is directed to stderr, when -i option applied

2004-09-21  Aleksey Cheusov <vle@gmx.net>

  * dictd.8:
  typos fixed

  * configure.in:
  nothing serious

2004-07-08  Aleksey Cheusov <vle@gmx.net>

  * dictdplugin_dbi.c:
  'utf8' flag is set TRUE by default
  'all_chars' flag is set to FALSE by default, unless 00-database-allchars
      is present in database
  added new options: "all_char" and "utf8"

  * dictunformat, dictunformat.1:
  documentation update

2004-06-15  Aleksey Cheusov <vle@gmx.net>

  * configure.in:
  fixed: because of '-lc -lc' passed to linker executables
      cannot be built on latest cygwin

2004-06-06  Aleksey Cheusov <vle@gmx.net>

  * NEWS: corrections

  * Makefile.in, configure.in:
  version ==> 1.9.14

  * NEWS:
  updated to 1.9.14

  * NEWS:
  fixed a typo

2004-05-30  Aleksey Cheusov <vle@gmx.net>

  * dictd.c:
  exit status of child processes is logged with '--log server' option.
  code clean-ups

  * dictd.c, net.c:
  detaching from terminal again

  * mbrlen.c, mbrtowc.c, mbstowcs.c:
  fixed: on systems having no mbrlen(3) function (FreeBSD4),
      dictfmt assert(3)s
      if run with 8-bit --locale option and headword contains
      0xFF or 0xFE symbols (for exsmple, KOI8-R and CP1251 character sets).

2004-05-25  Aleksey Cheusov <vle@gmx.net>

  * dictd.8: dosumentation update

2004-05-24  Aleksey Cheusov <vle@gmx.net>

  * dictfmt.c:
  "The original data was distributed..." message is wrapped to 72 (default)
      columns even if '--columns 0' was specified.

  * dictfmt.c:
  Special 00-database-XXX headwords do not affect 00-database-alphabet,
      i.e. only characters from "real" headwords
      are added to alphabet.
      This makes LEV search strategy a little faster,
      especially search in dictionaries
      containing non-Latin symbols like Cyrillic.

  * dict.1, dict.c:
  If a connection to DICT server faild, dict exits with exit status 41
  documentation update

2004-05-21  Aleksey Cheusov <vle@gmx.net>

  * dictd.8, dictd.c, net.c, net.h:
  dictd: added --listen-to option for binding socket to the specified address
  documentation update

2004-05-16  Aleksey Cheusov <vle@gmx.net>

  * dictd.c, net.c:
  'dictd' opens a log file (-L option) before releasing root priviledges.
      As a result log file can be created under /var/log directory
  log file and syslog is opened once.
  The error messages of sanity checks are written to log file (or syslog)
  "close everything" section has been removed from net.c:net_detach
      This is necessary because we open log file
      before detaching from a terminal

  * dictfmt.c:
  -t option implies '--columns 0' to preserve original formatting

2004-05-15  Aleksey Cheusov <vle@gmx.net>

  * daemon.c:
  fixed: SHOW INFO command sends incorrect data to the client if
      the information about database is set using 'info' keyword.
      Affected versions: 1.9.12-1.9.13

2004-05-14  Aleksey Cheusov <vle@gmx.net>

  * dictdplugin_dbi.c: fixed: warning message produced by compiler

  * NEWS: fixed misspell

2004-04-26  Aleksey Cheusov <vle@gmx.net>

  * codes.h:
  added: missing response code

  * dict.1, dict.c:
  exit status again: fixes, improvements, documentation update

2004-04-23  Aleksey Cheusov <vle@gmx.net>

  * dict.c:
  In case of an error, non-zero exit status returned by 'dict'

  * daemon.c:
  more information status message printed by dictd

2004-04-05  Aleksey Cheusov <vle@gmx.net>

  * dictd.8, dictd.c:
  SIGUSR1  causes  dictd  to unload databases. Then dictd returns 420 status
   (instead of 220). To load databases again,  send  SIGHUP  signal.  Because
   database  files  are  mmap'ed(2)  ,  it is impossible to update them while
   dictd is running.  So, if you need to update  database  files  and  reread
   configuration  file,  first,  send  SIGUSR1  signal  to  dictd  to  unload
   databases, update files, and then send SUGHUP signal to load them again.

2004-03-24  Aleksey Cheusov <vle@gmx.net>

  * example_plugin_dbi.conf: revert --> reverse

  * example_plugin_dbi.conf, NEWS, configure.in:
  version ==> 1.9.13
  another sample strategy for DBI plugin
  NEWS file update

  * dictd.c, dictdplugin_dbi.c:
  code clean-ups

  * plugin.c:
  log plugin failure to stderr

2004-03-23  Aleksey Cheusov <vle@gmx.net>

  * dictd.c, dictdplugin_dbi.c:
  fixes for call dictdb_free

2004-03-22  Aleksey Cheusov <vle@gmx.net>

  * index.c:
  fixed: if database has no 00-database-alphabet headword,
      "global" alphabet is built incorrectly. As a result
      dictd may work (FreeBSD - affected) incorrectly with LEV strategy.
      Affected versions: 1.9.12

2004-03-21  Aleksey Cheusov <vle@gmx.net>

  * Makefile.in, configure.in, dictdplugin_dbi.c, example_plugin_dbi.conf:
  ADDED: plugin using libdbi library for implementing DICT database using
    SQL server. It is possible to specify custom search strategies
    by specifying SQL query.

    The following option are currently supported:

      driverdir       - path to DBI drivers
      drivername      - DBI driver name
      option_host     - host to connect to
      option_port     - port to connect to
      option_dbname   - database name
      option_username - user name for authorizing to SQL server
      option_password - user password for authorizing to SQL server
      query_define    -        SQL query for implementing DEFINE command
      query_<SEARCHSTRATEGY> - SQL query for implementing
             SEARCHSTRATEGY (MATCH command).
             SEARCHSTRATEGY is not limited to the "standard" strategies.

    See the file example_plugin_dbi.conf for sample of how
      this plugin can be configured.

    SQL queries should return 1-column result by using SELECT command.
      %q sequence inside SQL query is expanded to user's query.
      %% is expanded to single % sign.

    This plugin obviously gives a simplest way to implement editable
      dictionaries, not by DICT protocol, but, for example, with a help
      of WEB interface.

    Hack! To resolv DBI driver's symbols, dictd is currently linked with
    libdbi. Later, this will be fixed.

2004-03-19  Aleksey Cheusov <vle@gmx.net>

  * dictd.c, dictdplugin_judy.c, lev.h, plugin.c:
  code clean-ups
  debugging code 'fprintf (stderr' code has been removed

2004-03-18  Aleksey Cheusov <vle@gmx.net>

  * dictdplugin_judy.c, heap.h, plugins_common.c, plugins_common.h:
  functions, common to plugins have been moved to plugins_common.{h,c}

  * heap.c:
  HEAP_MAGIC number is cheched by every heap_XXX function. (assert(3))

  * dictd.c, libmaa/maa.c:
  maa_shutdown function is not called automatically
      when application terminates. Run it explicitly.

2004-03-11  Aleksey Cheusov <vle@gmx.net>

  * Makefile.in, NEWS, configure.in:
  If lex and yacc are missing, ./configure shows an error message and exits

2004-03-10  Aleksey Cheusov <vle@gmx.net>

  * configure.in, libmaa/configure.in:
  dictd / libmaa version has been changed to 1.9.12 / 0.97

  * Makefile.in:
  'make dist' generates C code for lexers and parsers using flex and bison.
      So, lex/flex and yacc/bison are not necessary for building 'dictd'
      from tarball.

  * NEWS:
  update to 1.9.12

2004-03-06  Aleksey Cheusov <vle@gmx.net>

  * daemon.c:
  fixed: 'daemon_crlf' works incorrectly
      if argument 's' doesn't end with '\n' and 'dot' != 0
      (broken .dict file)

  * daemon.c:
  fixed: 'daemon_printf' function overflows buffer
      when a printed string is "\n".

2004-02-24  Aleksey Cheusov <vle@gmx.net>

  * nl_langinfo.c, dictP.h, dictd.c, dictfmt.c, configure.in:
  nl_langinfo function is used to detect
      whether dictd/dictfmt uses 8bit, utf-8, or C locale.

2004-02-23  Aleksey Cheusov <vle@gmx.net>

  * dictdplugin_judy.c:
  fixed: if a requested headword has more than one definition,
         DEFINE command always returns the first one

2004-02-07  Aleksey Cheusov <vle@gmx.net>

  * dictl.in:
  fixed: incorrect charset determination.
      Thanks to Roland Rosenfeld for report and patch.

2004-01-28  kirk  <kirk@asrock.chizhovka.net>

  * dictfmt.1, dictfmt.c:
  Added --break-headwords option for use with --headword-separator, so
  each headword is written on its own line of the .dict file.

2004-01-27  Bob Hilliard  <hilliard@debian.org>

  * dictfmt.1, dictfmt.c:
  Patched dictfmt.c to corrrect formatting of database-info with the -f
  option.
  Corrected typo in dictfmt.1

2004-01-25  Aleksey Cheusov <vle@gmx.net>

  * dictl.in, dictl.1:
  dictl analyses PAGER variable to set a pager.

  * dictl.1, dictl.in:
  dictl checks whether recode/iconv/konwert/locale commands are available

2004-01-24  Bob Hilliard  <hilliard@debian.org>

  * dictl.in, dictl.1:
  Modified dictl script to test for the presence of /usr/bin/recode,
  and default to using iconv if recode is not present.
  Update dictl.1 to mention this.

2004-01-16  Aleksey Cheusov <vle@gmx.net>

  * deps, dictdplugin.h, dictdplugin_judy.c, index.c, index.h, plugin.c:
  dictdplugin_judy implements the correct LEV search strategy
      for utf-8 dictionaries.
  Global 8-bit and ASCII alphabets (a list of alphanumeric and space characters)
      are passed to plugins (plugin.h)

2004-01-13  Aleksey Cheusov <vle@gmx.net>

  * dictfmt.c:
  00-database-short is added to .dict file because
      older dictd versions need it.

2004-01-08  Bob Hilliard  <hilliard@debian.org>

  * dictfmt.1:
  Clarified what goes into the 00-database-info and what is considered
  the first headword

2004-01-08  Aleksey Cheusov <vle@gmx.net>

  * dictd.c:
  'dictd --test|--test-file' notifies about invalid database name

  * mbrtowc.c:
  utf8_to_ucs4 acceps result == NULL

  * plugin.c:
  more verbose logging

  * str.c, str.h:
  function for copying utf-8 string represented
      as a sequence of MB_CUR_MAX+1 bytes

  * daemon.c, dictdplugin_judy.c, index.c, lev.h:
  code related to LEV strategy has been moved to lev.h

  * plugin.c:
  code cleanups

2004-01-07  Aleksey Cheusov <vle@gmx.net>

  * daemon.c, dictd.8, example_complex.conf:
  '{match,define} {*,!}' ignore invisible dictionaries.
      Now there is no reason to separate visible and invisible dictionaries
      by database_exit command, as a result
      this simplifies a configuration file.

  * dictfmt.c:
  special headwords are not copied to .dict file

  * index.c:
  insertions at the end of word for LEV strategy (utf-8)

  * index.c:
  lev strategy again

  * configure.in:
  fixed: typo

  * dictd.c:
  LC_CTYPE and LC_COLLATE are set.
      As a result date and time are printed to log using "C" locale.

2004-01-06  Aleksey Cheusov <vle@gmx.net>

  * dictfmt.1, dictfmt.c:
  added: --columns options to 'dictfmt' which sets a number of columns for
      wrapping text. See dictfmt.1. By default this value is 72.

  * dictP.h:
  #define for wcwidth(3) if it is not implemented

  * configure.in:
  added: test for presense of 'wcwidth' function

  * Makefile.in:
  'make distclean' removes autom4te.cache directories

  * dictfmt.c:
  'mbswidth_' also counts non-printable symbols (+1)

  * dictfmt.c:
  dictfmt correctly wraps utf-8 strings at pos 79

2004-01-05  Bob Hilliard  <hilliard@debian.org>

  * dictfmt.c: Fix formatting problems

2004-01-05  Aleksey Cheusov <vle@gmx.net>

  * dictfmt.c:
  'dictfmt -f' uses default FMT_MAXPOS
  'dictfmt -f' removes leading space character from definitions

  * dictl.in:
  fixed missing double quotes

  * defs.h, dictd.c, index.c:
  dictd's LEV search strategy works correctly with utf-8 dictionaries.
      You should rebuild your databases for this to work.
      dictfmt 1.9.12 or later is required.
      Special headword 00-database-alphabet is used.

2004-01-04  Aleksey Cheusov <vle@gmx.net>

  * dictfmt.c:
  special headwords are not copied to .dict file

2003-12-30  Aleksey Cheusov <vle@gmx.net>

  * dictunformat:
  00-database-alphabet is skipped

  * dictfmt.c: *** empty log message ***

  * dictfmt.c:
  fixes

  * dictfmt.c:
  new special headword 00-database-alphabet is created which will be used
      for implementing LEV strategy for utf-8 dictionaries.
      Its definition consists of all characters present in the headwords.

2003-12-24  Aleksey Cheusov <vle@gmx.net>

  * index.c:
  When utf-8 locale is set,
      'toupper' function is called for ascii characters only.

  * daemon.c:
  fixed: SHOW SERVER cuts off long database names

  * Makefile.in:
  fixed: 'make dist'.
      dictd-1.9.11 tarball was made without ChangeLog file.
      Now it is in its usual place.

2003-12-18  Aleksey Cheusov <vle@gmx.net>

  * Makefile.in:
  fix for 'make ChangeLog'

2003-12-08  Aleksey Cheusov <vle@gmx.net>

  * NEWS: *** empty log message ***

  * NEWS, configure.in, libmaa/configure.in:
  version        ==> 1.9.11
  libmaa version ==> 0.97
  NEWS update

  * dictfmt.c:
  added: --license|--version options
  some tricks about indentation

  * dictd.c, dictzip.c, dict.c:
  changed --license|--help|--version message

2003-12-05  Bob Hilliard  <hilliard@debian.org>

  * dictfmt.1:
  Clarified and extended test regarding database headers in dictfmt.1

  * dict.c, dictd.8, dictd.c, dictfmt.c:
  Added Usage: line to help message in dict.c, dictd.c, and dicfmt.c
  Clarified --locale requirements in dictd.8

2003-11-30  Aleksey Cheusov <vle@gmx.net>

  * NEWS:
  NEWS file becomes a part of dictd distribution

2003-11-26  Aleksey Cheusov <vle@gmx.net>

  * example_complex.conf:
  'lev' strategy is also disabled for standard databases

  * index.c:
  "'locale '%s' can not be used ..." error message is put to log file

2003-11-05  Aleksey Cheusov <vle@gmx.net>

  * Makefile.in:
  'make distclean' removes 'dictl' and 'colorit' executables

  * INSTALL, example_complex.conf:
  documentation update

2003-11-03  Aleksey Cheusov <vle@gmx.net>

  * Makefile.in, configure.in, defs.h, dictdplugin-config.in, dictdplugin.c, dictdplugin.h, plugin.c, strategy.h:
  constants for search strategies and function names
      are no longer in dictdplugin.h.
  removed a lindictdplugin.a
  colorit script and man page is installed and uninstalled by
     make install/make uninstall/make and install.colorit/make uninstall.colorit
     commands

  * colorit.1, colorit.in:
  'colorit' sets the  define HOME for a preprocessor
      using -D command line argument.
  Documentation update for 'colorit'

2003-10-31  Aleksey Cheusov <vle@gmx.net>

  * configure.in:
  CFLAGS is changed when we know exactly the plugins supported

  * configure.in:
  tests for presence of libJudy and Judy.h
  'configure' disables a plugin support automatically
    instead of showing an error message.
  'configure' shows some details about configuration before exiting

  * Makefile.in, configure.in:
  checks for libJudy and Judy.h

  * daemon.c, data.c, dictP.h, dictd.h, net.c, plugin.c, strategy.c:
  a bit of magic of #include's order. The result is that
      dictd* can be built on Solaris-9
  fixed: yet another warning message

2003-10-30  Aleksey Cheusov <vle@gmx.net>

  * configure.in:
  better checking for presence of functions which are not in libc

2003-10-28  Aleksey Cheusov <vle@gmx.net>

  * colorit.in:
  added: --pp, -h and -V aoptions
  Optional [files...] arguments are handled correctly

  * colorit.1:
  initial version od colorit.1

  * colorit.in:
  spaces are allowed inside regexps and inserted strings. In this case
  script becomes gawk-spesific (3.1?)
  m4 is used as a preprocessor by default

2003-10-27  Aleksey Cheusov <vle@gmx.net>

  * configure.in, dictP.h, dictfmt.c, getopt.c, getopt_long.c, setenv.c:
  'getopt_long' again
  'setenv' implementation for Solaris-9

2003-10-26  Aleksey Cheusov <vle@gmx.net>

  * dictl.in:
  ~ replaced for $HOME for shells that disalike it

  * configure.in, dictP.h, getopt.c, getopt_long.c:
  better checking for getopt_long. As a result dictd/dictfmt/dictzip/dict
      can be built on platforms having no getopt_long(3) present in GLIBC

  * dictzip.c, index.c:
  fixed: a warning messages produced on 64-bit archs

  * dictfmt.c:
  fixed : a warning messages produced by latest gcc

  * parse.c:
  changes necessary to compiledictd on MacOS-X 10.1 (cc - gcc2.95.2)

2003-10-22  Aleksey Cheusov <vle@gmx.net>

  * plugin.c:
  fixes for invisible + virtual + plugin
  strategies disabled by 'disable_strategy' keyword
       are not passed to plugins

  * example_complex.conf:
  new comments

  * index.c:
  fixes for 'invisible' + 'plugins' + 'virtual dictionaries'
  code cleanups

  * dictdplugin_judy.c:
  prefix strategy becomes simplier
  removed: local 'disable_strat' option

  * defs.h: *** empty log message ***

2003-10-20  Aleksey Cheusov <vle@gmx.net>

  * dictd.c:
  dictd correctly reloads configuration file when --pp is used

  * index.c:
  more verbose -dsearch

2003-10-14  Aleksey Cheusov <vle@gmx.net>

  * strategy.c, strategy.h, dictd.8, dictd.c, example_complex.conf, plugin.c, plugin.h, daemon.c:
  a few fixes

  * dictd.8, dictd.c, example_complex.conf, parse.c, parse.h:
  added: prs_file_pp function to parse.c
  added: dictd -pp <prog> sets a preprocessor for configuration files
      See dictd.8 and example_complex.conf.

2003-10-13  Aleksey Cheusov <vle@gmx.net>

  * configure.in:
  libnsl is really optional

  * dictdplugin_judy.c:
  word, soundex, re, regexp, suffix and substring strategies are removed
      from judy plugin because iterattion over keys is extremely slow.

  * example_complex.conf: *** empty log message ***

2003-10-11  Aleksey Cheusov <vle@gmx.net>

  * dictl.in:
  filename is doublequoted

  * index.c:
  fix for the previous fix ;-)

  * Makefile.in, configure.in:
  plugin support on FreeBSD-4.8

  * Makefile.in, clientparse.y, clientscan.l, configure.in, index.c, servparse.y, servscan.l:
  changes necessary to build dictd/dict/dictfmt/dictzip on FreeBSD4.8

2003-10-08  Aleksey Cheusov <vle@gmx.net>

  * ChangeLog:
  ChangeLog is removed from CVS repository.
      There is no need to it there because it can be built using
      'make ChangeLog'.

  * dictl.in:
  additional checks

  * colorit.in, configure.in:
  added: initial version of 'colorit', a simple script that can color your
      dict's output.

  * dictl.1, dictl.in:
  added: initial version of dictl

2003-10-02  Aleksey Cheusov <vle@gmx.net>

  * dictd.8:
  documentation update

  * daemon.c, dictd.c, index.c:
  info/name keywords in 'database_virtual' section can handle
      entry name beginning with @ symbol in a similar way
      as 'database' and 'database_plugin'

2003-10-01  Aleksey Cheusov <vle@gmx.net>

  * dictd.c: *** empty log message ***

  * defs.h, dictd.c, example_complex.conf, dictd.8, dictd.h, index.c, servparse.y, servscan.l:
  added: ability to disable stategy for a particular database
      using a keyword "disable_strategy".

      See dictd.8 and example_complex.conf

  * dictfmt.c:
  changes for making databases compatible with older dictd

  * config.guess, config.sub, libmaa/config.guess, libmaa/config.sub:
  updated config.{sub,guess} files

2003-09-30  Aleksey Cheusov <vle@gmx.net>

  * dictd.c, dictfmt.c:
  fixed: --headword-separator doesn't work with -f, -p and -v formats

  * dictfmt.c:
  fixed: dictfmt -f doesn't work correctly if the first two lines are empty
      Affected versions of dictfmt:  1.6.1-1.9.10

2003-09-28  Rik Faith <faith@dict.org>

  * dictfmt.c: Changes for updated VERA and FOLDOC databases

2003-09-19  Aleksey Cheusov <vle@gmx.net>

  * dictdplugin-config.in:
  fixed: typo

  * index.c, libmaa/source.c, libmaa/string.c, parse.c:
  a few strlcpy have been replaced with strncpy and memcpy

2003-09-05  Aleksey Cheusov <vle@gmx.net>

  * Makefile.in:
  'all' target is above 'samples' one

2003-09-04  Aleksey Cheusov <vle@gmx.net>

  * dictP.h:
  added: missing declaration of strlcat

  * configure.in, Makefile.in:
  removed: DICT{,ZIP,FMT,D}_LDFLAGS configure variables
  avoided: use of :: in makefile
  others changes

2003-09-01  Aleksey Cheusov <vle@gmx.net>

  * dictdplugin_judy.c:
  Judy plugin supports the following options
  (dictd(8): Plugin Specification, data section):

    disable_strat=exact
    disable_strat=prefix
    ...
    disable_strat=word

    This disables particular strategies.

  * Makefile.in, deps:
  fixed: missing -fPIC

2003-08-31  Aleksey Cheusov <vle@gmx.net>

  * dictdplugin_judy.c:
  judy-based plugin:
    additional checks for 'utf-8' and 'allchars' flags
      in plugin config and databases
    double-quotes are removed from the database file names

2003-08-28  Bob Hilliard  <hilliard@debian.org>

  * clientparse.y, dict.1, dictd.8:
  clientparse.y will accept "pager' as the pager
  dict.1 mentions that --enable-dictorg is disabled by default
  dictd.8 clarifies that dictd will fail to start in "C" locale if an
  8-bit or utf-8 dictionary is listed in dictd.conf,
  .

2003-08-27  Aleksey Cheusov <vle@gmx.net>

  * dictvd:
  initial version of dictvd

  * dictdplugin_judy.c:
  judy-based plugin uses default database directory

  * daemon.c, dictd.c:
  fixed: missing dictdb_free call
  patch by Michael Bunk <bunk@imn.htwk-leipzig.de> fixing:
         a typo giving the incomprehensible failure message,
         a typo resulting in 'dict --server-info' showing
           same compressed/uncompressed database sizes
         a bug that prevented all authentication to succeed

  * configure.in, strlcat.c:
  strlcat

  * config.h.in:
  config.h.in has been removed from CVS repository

  * dictdplugin.h, plugin.c:
  a default directory for databases
      is passed to plugins (DICT_PLUGIN_INITDATA_DEFDBDIR)

2003-08-18  Aleksey Cheusov <vle@gmx.net>

  * Makefile.in:
  'make cvsclean' and 'make dist' removes the temporary directory autom4te.cache

  * dictd.c:
  A multilined short name of the database is trancated.

2003-08-11  Aleksey Cheusov <vle@gmx.net>

  * dictdplugin_judy.c, heap.c, heap.h:
  code clean-ups
  fixed: 'word' strategy

  * Makefile.in, dictdplugin_judy.c, heap.c, heap.h:
  all malloc/free calls in Judy plugin have been replaced to
      calls of internal heap. Sometimes it works faster.
      This feature is #ifdef'ed

2003-08-11  Rik Faith <faith@dict.org>

  * README: Update instructions on how to join mailing lists

2003-08-10  Aleksey Cheusov <vle@gmx.net>

  * dictdplugin_exit.c:
  fixed: compiler warning message

  * Makefile.in, dictdplugin_judy.c:
  Judy-based plugin again

  * Makefile.in, dictdplugin_judy.c:
  memory leaks in Judy-based plugin fixed

2003-08-08  Aleksey Cheusov <vle@gmx.net>

  * dictdplugin_judy.c:
  buffer overflow in Judy-based plugin fixed

  * dictdplugin_judy.c:
  transposition section of 'lev' strategy doesn't produce
     the same word twice (apple, P<->P)
  added: 'word' strategy to Judy-based plugin

  * dictdplugin_judy.c:
  added: 'lev' strategy to Judy-based plugin

  * index.c:
  fixed: 'Substitutions' section inside 'dict_search_levenshtein' function
      produces a lot of equal words

  * dictdplugin_judy.c:
  added: 'substring' strategy to Judy-based plugin

  * dictdplugin_judy.c:
  added: 're' and 'regexp' strategies to Judy-based plugin

  * str.c, str.h, Makefile.in, dictd.c, dictdplugin_judy.c, dictfmt.c, index.c:
  code clean-ups. Common string-related functions have been moved to str.c

  * dictdplugin_judy.c:
  added: suffix, prefix and soundex strategies to Judy-based plugin

  * index.c:
  fixed: 'suffix' strategy doesn't ignore characters other than
     alphanumeric and spaces. Affected versions: 1.9.1-1.9.10

  * defs.h, plugin.c:
  one dictdb_free call for one call of dictdb_search

2003-08-07  Aleksey Cheusov <vle@gmx.net>

  * Makefile.in, dictdplugin_judy.c, libmaa/maaP.h, libmaa/strlcpy.c:
  added: initial version of Judy-based plugin

  * dictdplugin_popen.cpp:
  fixed: gcc-3.3 warning message

2003-08-06  Aleksey Cheusov <vle@gmx.net>

  * Makefile.in, config.h.in, configure.in, dictP.h, dictfmt.c, dictzip.c, index.c, libmaa/config.h.in, libmaa/configure.in, libmaa/maaP.h, libmaa/source.c, libmaa/string.c, libmaa/strlcpy.c, parse.c, plugin.c, strategy.c, strlcpy.c:
  'strncpy' function is replaced with 'strlcpy' in both dict* and libmaa

  * dictdplugin_popen.cpp: *** empty log message ***

  * plugin.c:
  code clean-ups
  NULL/-1 is passed to plugin as DICT_PLUGIN_INITDATA_DICT

  * dictd.c:
  logging clean-ups
  fixed: dictd doesn't call plugin's dictdb_free function
      if --test-nooutput is applied (only commands for debugging are affected)

2003-08-01  Aleksey Cheusov <vle@gmx.net>

  * plugin.c:
  more informative -dinit loggin

  * dictd.8:
  Documentation update

  * dictfmt.c:
  code clean-ups
  fixed: --without-headword

2003-07-22  Aleksey Cheusov <vle@gmx.net>

  * ChangeLog:
  ChangeLog is up-to-date

  * Makefile.in, configure.in, libmaa/configure.in:
  Local libmaa is always used. This will be removed later.
  DICTD version --> 1.9.10
  LIBMAA version --> 0.96

2003-07-21  Aleksey Cheusov <vle@gmx.net>

  * daemon.c, dictd.8, dictd.c:
  'filter' option is implemented. Thanks to
      Michael Bunk <bunk@imn.htwk-leipzig.de> for the patch.

2003-07-16  Aleksey Cheusov <vle@gmx.net>

  * INSTALL, dictd.8:
  Documentation update

2003-07-15  Aleksey Cheusov <vle@gmx.net>

  * Makefile.in:
  hide e-mails from ChangeLog

  * index.c:
  fixed: 'lev' strategy ('pple' query doesn't match 'apple' word)
      Affected versions: 1.4.9 - 1.9.9

  * index.c:
  insignificant speed-up of 'lev' strategy

2003-07-10  Aleksey Cheusov <vle@gmx.net>

  * Makefile.in, configure.in:
  DICT_LDFLAGS, DICTD_LDFLAGS, DICTZIP_LDFLAGS and DICTFMT_LDFLAGS
      variables can be used while configure for specifying
      specific LDFLAGS for a particular executable.

      If you want to build dictd with TRE regex engine, for example, run
      DICTD_LDFLAGS='-L/usr/local/lib -ltre' CPPFLAGS='-I/usr/local/include' \
       ./configure

2003-07-09  Aleksey Cheusov <vle@gmx.net>

  * dictfmt.c:
  fix

2003-07-07  Aleksey Cheusov <vle@gmx.net>

  * Makefile.in: *** empty log message ***

  * Makefile.in, configure.in, dict.c, dictd.c, include_regex.h.in, index.c, parse.c, parse.h:
  parse.{c,h} is a part of dictd.
  fixed: AC_MSG_ERROR calls
  By default system-wide regex engine is used is found.
      You can also use your favourite regex engine by setting
      LDFLAGS and/or CPPFLAGS variables and optionally
      ./configure --with-regex-include=FILE.
      In order to build dictd with local regex enbgine,
      run ./configure --with-local-regex.
  upgrade to autoconf 2.53
  fixed: incorrect detection of external libmaa (libmaa_init requires arguments)

  * search_man:
  'search_man' example outputs plain text

  * index.c:
  dict_match function

  * config.h.in:
  upgrade to autoconf 2.53

  * index.c:
  fixed: RE and REGEXP strategies
      (^apple|orange and ^apple\|orange doesn't match a word 'orange')

  * configure.in:
  System functions wcXXX and mbXXX are used if present.

2003-06-23  Aleksey Cheusov <vle@gmx.net>

  * dictfmt.c:
  fixed: incorrect spaces trimming.
      Thanks to Kuang-che Wu <kcwu@kcwu.homeip.net> for the bug report

2003-06-10  Aleksey Cheusov <vle@gmx.net>

  * dictfmt.c, dictfmt.1:
  added: -t option for 'dictfmt'
  'dictfmt' documentation update

  * dictd.8:
  a few fixes

  * dict.c, configure.in, Makefile.in:
  By default the predefined DICT servers dict.org and alt0.dict.org
      are disabled. If you want to use them, run
      ./configure --enable-dictorg

  * dictfmt.c:
  'dictfmt' doesn't append an empty line to definitions

  * dictfmt.c:
  00-database-{info,short,url} are processed in the same
      way as 00database{info,short,url}

2003-05-30  Bob Hilliard  <hilliard@debian.org>

  * dictd.8: Added mention ot SIGHUP causing dictd to re-read the configuration
  file, and removed BUG note saying this can't be done.

2003-05-23  Aleksey Cheusov <vle@gmx.net>

  * dictd.8, dictfmt.1, dictfmt.c, dictunformat:
  added: dictfmt --without-info
  'dictfmt' and 'dictunformat' works better with each other. In particular
      'dictunformat' outputs 00-database-{url,short,info} headwords
      and 'dictfmt' copy 00-database-{url,short}
      headwords to .dict file if -u and -s options
      are not applied respectively.
      For 00-database-info headword see --without-info option.
  'dictfmt' documentation update

2003-04-30  Aleksey Cheusov <vle@gmx.net>

  * Makefile.in:
  fixed: some problems with 'make install'.
      Thanks to Kurt Wall <kwall@kurtwerks.com> for remarks

2003-04-14  Aleksey Cheusov <vle@gmx.net>

  * ChangeLog:
  ChangeLog is up-to-date

  * INSTALL:
  a few words about cygwin

  * configure.in:
  version ==> 1.9.9

  * Makefile.in: better cygwin support

  * libmaa/config.h.in, config.h.in: *** empty log message ***

  * configure.in, Makefile.in:
  better cygwin support

  * dictd.c:
  fixed: warning message produced by gcc under cygwin

  * daemon.c:
  file descriptors are explicitly initialized

2003-04-10  Aleksey Cheusov <vle@gmx.net>

  * configure.in, defs.h, dictP.h, dictd.c, plugin.c, plugin.h, Makefile.in, config.h.in:
  'libdl' is used instead of 'libltdl' on platforms where it is available
  dictP.h cleaups

2003-04-09  Aleksey Cheusov <vle@gmx.net>

  * dict.c:
  nothing

  * dict.c, snprintf.c, vsnprintf.c:
  err_fatal(..."Buffer too small\n" ); have been moved to
      snprintf.c and vsnprintf.c
  all sprintf() in the dict.c have been replaced with snprintf()

  * dictP.h, config.h.in, configure.in:
  dictP.h and configure.in clean-ups
      Thanks to Kimura Fuyuki <fuyuki@hadaly.org> for remarks

2003-04-09  Bob Hilliard  <hilliard@debian.org>

  * dict.c: Patched to prevent segfault/buffer overrun on excessively long
  dict command lines
  .
  .

2003-04-07  Aleksey Cheusov <vle@gmx.net>

  * configure.in:
  fixed: 'dictd' can not be configured with ./configure --with-local-zlib

  * index.h, dictd.c, index.c, dictd.8:
  added: dictd --fast-start (implied by --inetd) improves dictd's performance
      if it is run from inetd or on platforms without copy-on-write (CYGWIN).

  * dictd.8:
  documentation update

  * dictd.h, dictd.c, daemon.c:
  SHOW SERVER command doesn't show uptime/forks statistics,
      if the dictd is run from inetd.

  * index.c, dictd.h, dictd.c, dictd.8, daemon.c:
  added: dictd inetd support (dictd --inetd)
      Thanks to Joey Hess <joeyh@debian.org>
      and Robert D. Hilliard <hilliard@debian.org> for the patch.

2003-03-27  Aleksey Cheusov <vle@gmx.net>

  * dictP.h:
  fixed: compilation error

2003-03-26  Aleksey Cheusov <vle@gmx.net>

  * ChangeLog:
  ChangeLog is up-to-date

  * configure.in:
  version == 1.9.8

2003-03-24  Aleksey Cheusov <vle@gmx.net>

  * data.c:
  fixed: incorrect dzip format detection
  fixed: possible crash while reading too long COMMENT or FNAME fields of
      the dzip'ed file

2003-03-19  Aleksey Cheusov <vle@gmx.net>

  * libmaa/maaP.h, strategy.c, strategy.h, vsnprintf.c, wcrtomb.c, wctomb.c, index.c, index.h, mbrlen.c, mbrtowc.c, mbstowcs.c, mbtowc.c, plugin.c, plugin.h, snprintf.c, dictdplugin.h, dictfmt.c, dictzip.c, dictd.h, dictd.c, dictP.h, defs.h, data.h, data.c, config.h.in, configure.in, daemon.c, Makefile.in:
  Functions related to plugin have moved to plugin.c.
  Several declarations have been moved to defs.h, index.h, data.h, plugin.h
      It makes sources easier to understand (at least for me)
  UTF-8 support is optional. It is disabled on platforms which don't
      support 'iswalnum', 'iswspace' and 'towlower' functions.
      As a result 'dictd' can be compiled on CYGWIN.
  fixed: 'dictdb_free' function is not called

2003-03-09  Aleksey Cheusov <vle@gmx.net>

  * ChangeLog: ChangeLog is up-to-date

  * dictd.c: nothing serious

  * index.c, dictd.c:
  function related to plugin are #ifdef'ed
  added: additional sanity check for disabling database_plugin keyword
      if dictd is compiled without plugin support

  * ChangeLog:
  ChangeLog is up-to-date

  * configure.in:
  version ==> 1.9.7

2003-03-04  Aleksey Cheusov <vle@gmx.net>

  * data.c:
  fixed: error message

2003-03-03  Aleksey Cheusov <vle@gmx.net>

  * Makefile.in:
  fixed: bug in 'make samples'. It requires installed 'dictfmt'.

  * Makefile.in:
  'make dist' makes distribution tarball by CVS tag

  * dictd.c, dictd.8:
  Documentation update for 'dictd --add-strategy'

  * strategy.h, strategy.c, index.c, dictd.c, dictd.h, daemon.c, Makefile.in:
  All functions related to strategies have been moved to strategy.{h,c}
  added: '--add-strategy' option for 'dictd' which allows
      to implement (with a help of plugins)
      new strategies not available in 'dictd'.
      For example, 'revert' strategy may be implemented.
      By using '--with-strategy' and '--add-strategy' options you
      can create DICT server with the set of strategies you need.

  * dictdplugin_popen.cpp:
  fixed: initializing the array with zeros

2003-03-02  Aleksey Cheusov <vle@gmx.net>

  * daemon.c, dictd.c, dictd.h:
  fixed: DEFINE and MATCH commands return '0 definitions found' but the
      550 exit code, if the invalid database name is specified.

  * dictd.8, servscan.l:
  'string' token in a configuration file supports \", \\, \n, \<NL>
      escape sequences.
      \<NL> (multilined strings) may be useful for specifying plugin data
      or an information about database.

  * index.c:
  critical fix: dictd may crash on BMH search
      (substring, suffix and word strategies) because
      it accesses memory outside mmap'ed region.

      Affected versions: 1.4.9-1.9.5 (All?)

  * ChangeLog: ChangeLog is up-to-date

  * configure.in:
  version == 1.9.6

  * index.c:
  critical fix: dictd may crash on BMH search
      (substring, suffix and word strategies) because it accesses memory
      outside mmap'ed region.

2003-02-28  Aleksey Cheusov <vle@gmx.net>

  * index.c, dictdplugin_popen.cpp:
  fixed: dictWord structures are not initialized with zeros

  * index.c: removed: something strange

2003-02-23  Aleksey Cheusov <vle@gmx.net>

  * daemon.c, dictd.c, dictd.h:
  fixed: if the 'name' keyword is used in database section, and
      it doesn't begin with '@', dictd may crash on SIGHUP.

      Affected versions: 1.9.1-1.9.4.

  The upper visible virtual dictionary is returned by DEFINE and MATCH
      commands if the actual definition/match is found in invisible dictionary.

  * ChangeLog:
  ChangeLog is up to date

  * configure.in:
  version ==> 1.9.5

  * dictd.c:
  fixed: if the 'name' keyword is used in database section, and
      it doesn't begin with '@', dictd may crash on SIGHUP.

      Affected versions: 1.9.1-1.9.4.

  * data.c, dictd.8, dictd.c, index.c, daemon.c:
  The only required keyword for the virtual database is database_list.
  The '@' symbol in 'name' and 'info' keywords is treated especially.

  * dictd.c:
  plugin specified in the config file also uses default plugin directory

  * daemon.c:
  'info' keyword understand prefix '@' too

  * dictd.c, index.c:
  fixed: short name is initialized before plugin initializing

  * dictd.h, index.c:
  code cleanups
  fixed: bug in passing database names to the plugin

  * configure.in:
  fixed: ./configure --with-nec-socks5

  * daemon.c, dictd.8, dictd.c, dictd.h, dictdplugin.h, index.c, servparse.y, servscan.l:
  added: ability to specify plugin in the configuration file
  documentation update
  added: additional sanity checks

  * daemon.c:
  dict_search_databases function has been simplified

  * servscan.l, dictd.8, dictd.c, dictd.h, servparse.y, daemon.c:
  added: ability to specify virtual dictionary in the configuration file.
      'database_virtual', 'database_list' keywords are added.
  documentation update
  added: 'info' keyword for specifying information about the database
      in the config file. @ prefix is supported.
  added: additional sanity checks

  * dictd.h, servparse.y, daemon.c, dictd.c:
  explicit flag is used for database_exit but the NULL indexFilename

2003-02-21  Aleksey Cheusov <vle@gmx.net>

  * daemon.c:
  debugging command has been removed

  * daemon.c:
  SHOW SERVER command word correctly with invisible databases

  * data.c, dictd.c, dictd.h, servparse.y, servscan.l, daemon.c:
  The keyword 'invisible' may be used inside 'database' section of
      the dictd configuration file.
      This means that the specified dictionary will not be shown to the clients.
      Currently DEFINE and MATCH command returns '*' as a dictionary name.
      Later the name of topmost virtual dictionary will be returned.
      There is no sense to make dictionary invisible if it is included to
      '*' dictionary (i.e. not preceded by dictionary_exit command)

  * dictfmt_plugin:
  fixed: usage message
  'dictfmt_plugin' fails if plugin filename is not specified

2003-02-20  Aleksey Cheusov <vle@gmx.net>

  * servscan.l:
  fixed: dictd.8 says that 'string' can be continued between lines
       but it can not. Now backslash at the end of line (between two " symbols)
       means new line character.

  * configure.in:
  added: ./configure --with-nec-socks5 for those who are behind socks server
       This causes linking with socks5 library both 'dictd' and 'dict'.

2003-02-15  Aleksey Cheusov <vle@gmx.net>

  * ChangeLog:
  ChangeLog is up-to-date

  * configure.in:
  version ==> 1.9.4

  * dictd.8:
  fixed: misprint in the documentation

2003-02-10  Aleksey Cheusov <vle@gmx.net>

  * configure.in:
  AC_REPLACE_FUNCS(towlower) -> AC_CHECK_FUNCS

  * dictfmt_virtual.1, index.c, dictd.h, dictd.c, config.h.in:
  added: 'dictfmt' adds 00-database-8bit entry to the 8-bit dictionaries.
         'dictd' uses this entry (and 00-database-utf8)
         and fails if "C" locale is specified
         and 8-bit or utf-8 dictionaries are encountered.

         Using "C" locale for 8-bit and utf-8 dictionaries is one of
         the most common error made by dictd users.

  * dictfmt_virtual:
  nothing serious

  * dictfmt.c, dictunformat:
  'dictfmt' fails if --locale="C" (the default) is specified and 8-bit
      head word is encountered.

2003-02-07  Aleksey Cheusov <vle@gmx.net>

  * dictfmt_index2word:
  'dictfmt_index2word' failes if it is run with the locale "C" and
      index file contains 8-bit head words.

  * dictfmt_index2suffix:
  'dictfmt_index2suffix' failes if it is run with the locale "C" and
      index file contains 8-bit head words.

  * dictfmt.c:
  'dictfmt' run with "C" locale cannot build dictionary containing 8-bit words

  * dictfmt_index2suffix, dictfmt_index2word:
  fixed: problems with filenames containing spaces

  * Makefile.in:
  new man pages are installed/uninstalled

  * configure.in, dictfmt_index2suffix.1, dictfmt_index2word.1, dictfmt_virtual.1, dictunformat.1:
  documentation update

  * Makefile.in:
  fixed: bug in 'samples' target

2003-02-06  Bob Hilliard  <hilliard@debian.org>

  * dictunformat.1, dictfmt_index2word.1, dictfmt_virtual.1, dictfmt_index2suffix.1:
  Really added dictfmt_virtual.1, dictunformat.1, dictfmt_index2word.1,
  and dictfmt_index2suffix

2003-02-02  Bob Hilliard  <hilliard@debian.org>

  * dict.c, dictd.8:
  Fixed dict.c to accept --serverinfo option, minor changes to dictd.8
  Added dictfmt_index2suffix.1, dictfmt_index2word.1, dictfmt_virtual.1,
  and dictunformat.1

2003-01-21  Aleksey Cheusov <vle@gmx.net>

  * dictfmt_index2word:
  awk script inside conforms to posix

2003-01-19  Aleksey Cheusov <vle@gmx.net>

  * vsnprintf.c, snprintf.c, dictfmt.c, dictzip.c, dictd.c, daemon.c, configure.in, config.h.in:
  'dictd', 'dictfmt' and 'dictzip' use snprintf and vsnprintf functions
      instead of sprintf and vsprintf on platforms where they are available.

  * dictd.c:
  added: --test-nooutput and --test-idle debugging options to 'dictd'
         They allow to test search speed:
           time_of(dictd --test-nooutput) - time_of (dictd --test-idle)
  fixed: bug with a debugging option --test-match
         Actually it made a DEFINE search

  * dictfmt_virtual, dictfmt.c, dictfmt_plugin:
  added: --silent, --quiet, -q options to 'dictfmt'

  * dictd.h, index.c:
  This significantly speeds up plugin-based search

  * ChangeLog:
  ChangeLog conforms dictd-1.9.3

  * index.c:
  more informative error message

  * dictdplugin_popen.cpp: *** empty log message ***

  * dictfmt_plugin:
  'dictfmt_plugin' doesn't add header and url to the .dict file

  * dictd.c:
  added: additional check for empty database list

2003-01-17  Aleksey Cheusov <vle@gmx.net>

  * configure.in:
  version = 1.9.3

  * dictd.c:
  fixed: dictd may crash when access section of
         the configuration file is empty

2003-01-16  Bob Hilliard  <hilliard@debian.org>

  * dictfmt_virtual, servparse.y:
  Patched servparse.y to make dict -D give a nicer message for
  database_exit.
  Patched dictfmt_virtual-patch to prevent failing when optional
  argument info_files is omitted

2003-01-16  Aleksey Cheusov <vle@gmx.net>

  * ChangeLog:
  ChangeLog is up-to-date

2003-01-15  Aleksey Cheusov <vle@gmx.net>

  * configure.in:
  version=1.9.2

  * dictunformat:
  'dictunformat' can handle databases containing more than one headwords
      for a single definition
  added: --headword-separator argument to 'dictunformat' utility

2003-01-14  Aleksey Cheusov <vle@gmx.net>

  * wcrtomb.c:
  added: wcrtomb.c

  * utf8_ucs4.c, utf8_ucs4.h, wctomb.c, mbtowc.c, mbstowcs.c, mbrtowc.c, mbrlen.c, configure.in, Makefile.in:
  multibyte character oriented functions are implemented in mb*.c and wc*.c
    files and they are used by default instead of standard ones.
    It seems glibc-2.1.3 has broken wcrtomb.

2003-01-09  Aleksey Cheusov <vle@gmx.net>

  * index.c, dictunformat:
  mbstate_t

  * Makefile.in:
  install/uninstall makefile's targets use DESTDIR environment variables.
         This simplifies building RPMs.

2003-01-08  Bob Hilliard  <hilliard@debian.org>

  * dictzip.c, index.c:
  Patched dictzip.c to revent segfault on excessively long command lines
  Patched index.c so dictd will startup without error if config file
  includes the /dev/null database

2003-01-03  Aleksey Cheusov <vle@gmx.net>

  * index.c:
  mbstate_t is not used

  * data.c, dictd.c, dictfmt.c, index.c, ChangeLog, Makefile.in, config.h.in, configure.in, daemon.c:
  functions from utf8_ucs4.c have been replaced with the standard ones.
  a few changes in configure.in
  DEFINE command returns an error message (MATCH command stops the search)
    for invalid utf-8 query (This is a trick!!!)
  dictfmt is linked with libmaa
  added: the following options to dictfmt:
         --without-header
         --without-url
         --without-time

2002-12-25  Aleksey Cheusov <vle@gmx.net>

  * Makefile.in:
  'dictunformat' is installed and uninstalled like 'dictfmt'

  * dictunformat, index.c:
  fixed: typo
  added: dictunformat which is able to extract dictionary
         from .dict and .index files.
         This may be used to recreate database from 8-bit character sets
         to utf-8 or to another format

2002-12-17  Aleksey Cheusov <vle@gmx.net>

  * ChangeLog:
  ChangeLog is up-to-date

  * libmaa/config.sub, libmaa/configure.in, ChangeLog, configure.in, dict.c, utf8_ucs4.c:
  code cleanups
  libmaa version set to 0.95
  dictd version set 1.9.1

2002-12-15  Bob Hilliard  <hilliard@debian.org>

  * dict.c:
  Modified client_print_listed() to make dict -D and dict -S print long
  names sanely.
  .
  .

2002-12-10  Aleksey Cheusov <vle@gmx.net>

  * dictd.h:
  fixed: problems in building 'dictd' without plugin support

  * configure.in:
  fixed: Even if you run ./configure with --disable-plugin, ltdl.h is needed

  * configure.in:
  configure.in: version number 1.8.0 ==> 1.9.0

2002-12-05  Aleksey Cheusov <vle@gmx.net>

  * search_man:
  fixed: forgot to remove sending a debugging e-mail message

2002-12-04  Aleksey Cheusov <vle@gmx.net>

  * example_virtual.conf:
  fixed: typo

  * ChangeLog:
  ChangeLog is up to date

  * index.c:
  Plugin version == 1 is disabled. Version == 0 is allowed only.

  * dictd.c, example_virtual.conf, index.c, servparse.y, servscan.l, daemon.c, data.c, dictd.8:
  added: 'database_exit' directive to dictd.conf.
         You can use 'virtual' dictionaries without plugin support.
         See man dictd.8 and example_virtual.conf for details.
  fixed: crash during debugging (-dsearch) output (80 chars limit)

2002-12-03  Aleksey Cheusov <vle@gmx.net>

  * dictdplugin_popen.cpp, example_popen.conf, index.c, search_man, dictdplugin.h, dictdplugin_exit.c, INSTALL, Makefile.in, daemon.c, data.c, dictd.h, dictdplugin-config.in:
  fixed: warning messages produced by gcc
  added: example 'popen' plugin. FOR PLUGIN DEMONSTRATION ONLY.
  added: popen plugin dictdplugin_popen.cpp. See INSTALL section 5.
  added: plugins can operate with strategies.
         See DICT_PLUGIN_INITDATA_STRATEGY constant,
           dictPluginData_strategy structure from dictdplugin.h and
           dictdplugin_popen.cpp for a sample of use

  * dictd.c:
  fixed: non-critical memory leaks again

  * dictd.h, dictdplugin-config.in, dictfmt_plugin, index.c, Makefile.in, dictd.8, dictd.c:
  By default (if not full filename name specified) plugins/dictionaries will be
    searched in $datadir/$libexecdir directory. It is a compile time option.
    See man dictd.
  added: dictdplugin-config --dictdir and --plugindir options

2002-12-02  Aleksey Cheusov <vle@gmx.net>

  * dictd.c:
  fixed: not critical memory leak

  * dictd.h, index.c: *** empty log message ***

  * dictd.8:
  documentation update

2002-11-28  Aleksey Cheusov <vle@gmx.net>

  * INSTALL, TODO, dictd.8, dictfmt_plugin, example2.conf, example3.conf:
  documentation update

2002-11-25  Aleksey Cheusov <vle@gmx.net>

  * servparse.y:
  servparse.y: fix by Dima Dorfman <d+dict@trit.org>

2002-11-19  Aleksey Cheusov <vle@gmx.net>

  * daemon.c:
  dictd can processes several conversions made by plugin.
    Example: if the plugin converts 'found' word to 'find' and 'found',
             all following dictionaries will be searched for both
             'find' and 'found'
    Example: if the plugin converts 'fruit' word to 'apple' and 'orange',
             all following dictionaries will be searched for both 'apple'
             and 'orange'

  * libmaa/text.c, utf8_ucs4.c, dictfmt.c, index.c:
  fixed: problems with 'toupper/tolower/isXXXX (-1)
  fixed: possible crash in libmaa/text.c:txt_soundex

  * dictfmt.c:
  fixed: invalid calculating the UTF-8 string length
         while formatting the dictionary

2002-11-04  Bob Hilliard  <hilliard@debian.org>

  * config.sub, config.guess:
  updated config.sub and config.guess to September 02 values
  .

2002-10-29  Aleksey Cheusov <vle@gmx.net>

  * utf8_ucs4.c:
  fixed: utf8_ucs4.c:strlen_utf8

2002-10-28  Aleksey Cheusov <vle@gmx.net>

  * ChangeLog, Makefile.in, configure.in, daemon.c, dictd.c, dictd.h, dictfmt_plugin, dictfmt_virtual:
  added: 'dictfmt_virtual' utility for creating virtual dictionary
  ADDED: Virtual dictionary capability for 'dictd'.
         Run 'dictfmt-virtual --help' for a help

  * configure.in, dictd.c, ChangeLog:
  SIGHUP causes 'dictd' to reload configuration file

2002-10-18  Bob Hilliard  <hilliard@debian.org>

  * dictfmt.1, dictfmt.c, dictd.8:
  Updated dictd.8 to include options added in 1.8.0.
  Updated dictfmt.c to correct previous errors and omissions and include
  options added in 1.8.0.
  Patched dictfmt.c to correct help message for -c5 and to fix the bug
  that caused the last headword read in to be duplicated in the index.

2002-10-17  Aleksey Cheusov <vle@gmx.net>

  * daemon.c, dictd.c, dictd.h:
  removed: --define-strategy option for 'dictd'
  renamed: --match-strategy ==> --default-strategy
  added:   --disable-strategy option for 'dictd'

2002-10-16  Aleksey Cheusov <vle@gmx.net>

  * dictfmt.c:
  fixed: typo

2002-10-14  Aleksey Cheusov <vle@gmx.net>

  * index.c: *** empty log message ***

  * servparse.y, servscan.l, index.c, dictfmt_index2suffix, dictfmt_index2word, dictd.h, dictd.c, daemon.c, Makefile.in:
  fixed: missing dependancy in Makefile.in
  added: fast implementation (binary search) of the WORD strategy search.
         This requires additional index file created by dictfmt_index2word
  added: --test-match option to dictd executable
  fixed: problems with suffix strategy using additional index file

  * daemon.c, dictdplugin.h, index.c:
  ADDED: new search strategy 'word'
  fixed: uninitialized variable charcount from index.c:dict_table_init

2002-10-11  Aleksey Cheusov <vle@gmx.net>

  * daemon.c, dictd.c, ChangeLog:
  added:   --match-strategy argument to dictd.
           It sets the default strategy for 'match' queries
  added:   --define-strategy argument to dictd.
           It sets the default strategy for 'define' queries
  update ChangeLog

2002-09-27  Aleksey Cheusov <vle@gmx.net>

  * libmaa/config.h.in, libmaa/configure.in, libmaa/error.c, ChangeLog, Makefile.in, config.h.in, configure.in, daemon.c, data.c, dictP.h, dictd.c, dictd.h, dictdplugin.c, dictdplugin.h, dictdplugin_exit.c, index.c:
  added: possibility to disable plugin support
         by running ./configure --disable-plugin
  fixed: problems with make -j. patch by
         Andrzej Dopierala <undefine@aramin.one.pl>
  fixed: problems with make ChangeLog
  added: possibility to build 'dictd' on platforms not supporting mmap()
  added: a lot of 'const' modifyers
  removed: 'goto' statement ;) from daemon.c
  added: --test-file argument to 'dictd'
         '--ftime' and '--test-file' are synonyms
  'dictd --test-file' and 'dictd --test' now search in ALL databases
         but the first one only.
  added: --test-db to 'dictd'
         It sets the database name for --test and --test-file.
  plugin function dictdb_open can return version == 1.
         In this case before each 'dictdb_search' call, 'dictdb_set'
         should be called. Not fully implemented.
  added:  DICT_PLUGIN_INITDATA_DBNAME data id for initialising plugin
         the databases names are passed to the plugins
         by the call of 'dictdb_open'
         This can be used to implement "virtual" databases such as
         "English monolingual" containing Webster, FOLDOC, WordNet etc...
  added: new plugin exit status DICT_PLUGIN_RESULT_EXIT
         which allows to stop searching.
         This is an easiest way to exclude some databases from '*' list.
         Example:
           1) Webster
           2) Wordnet
           3) ----- dictdplugin_exit.so plugin -----
           4) man pages
           5) RFC documents
           6) HOWTOs
           7) C++ functions
           8) Perl functions
         Using such database list, you will search
         only Webster and Wordnet databases
         by running 'dict apple'.
         If you want to get RFC document e.g., specify database name explicitly.
         Of course, plugin may exit with such exit status
         not only unconditionally
  added: dictdplugin_exit.so plugin
         Stops searching unconditionally.
  added: new plugin exit status DICT_PLUGIN_RESULT_PREPROCESSED
         which allows to implement a preprocessor of the requested word.
         Simple examples:
           - Converting German umlauts to UE, OE etc.
           - Converting Cyrillic YO character to YE
         After plugin converts the requested word, all following databases
         will be searched for converted one.
         In order this to work, it is necessary to create .index files
         without umlauts and Cyrillic YO characters.
         Database list example:
           1) ---- plugin converting German umlauts ------
           2) ---- plugin converting Cyrillic YO to YE ---
           3) German-English dictionary
           4) Russian-English dictionary
  fixed: bug in 'dict_search_plugin' function

2002-09-18  Aleksey Cheusov <vle@gmx.net>

  * dictfmt.c:
  dictfmt: --headword-separator doesn't imply --without-headword

2002-09-17  Aleksey Cheusov <vle@gmx.net>

  * dictdplugin.c, dictdplugin.h:
  constant strings definitions have been moved to dictdplugin.c

  * index.c:
  fixed: memory leak

2002-09-16  Aleksey Cheusov <vle@gmx.net>

  * Makefile.conf, Makefile.in, config.h.in, configure.in, daemon.c, dictd.c, dictd.h, dictdplugin-config.in, dictdplugin.c, dictdplugin.h, doc/Makefile.in, index.c, libmaa/Makefile.in, libmaa/config.h.in, libmaa/configure.in, plugin.h, INSTALL:
  fixed: bug in configure.in
         ./configure --sysconfdir was completely ignored
  changed: The default "prefix" directory from /usr to /usr/local
         just like most other packages do.
  removed: --with-etcdir argument of configure script.
         Use --sysconfdir instead.
         Run "./configure --prefix /usr --sysconfdir /etc" to
             get "configure" script behaviour
         similar to older dictd "configure".
  plugin improvements/changes:
    - plugin.h renamed to dictdplugin.h
    - In order to avoid confusing
      several #defines have been renamed.
      Now all #defines have DICT_ prefix.
    - "all" Makefile target builds library libdictdplugin.a.
      Link plugins with it.
    - dictdplugin-config configuration tool. It is like gtk-config.
  Error message is returned by dictd if the request is
     not a valid UTF-8 string and remaining databases will not be checked.
  fixed: warning messages produced by autoreconf

2002-09-13  Rik Faith <faith@dict.org>

  * ChangeLog: Update ChangeLog

2002-09-12  Aleksey Cheusov <vle@gmx.net>

  * configure.in, daemon.c, data.c, dictd.c, dictd.h, dictfmt_plugin, dictzip.c, index.c, plugin.h, utf8_ucs4.c, utf8_ucs4.h:
  fixed: crash while debugging output (80 chars limit)
  fixed: a lot of memory leaks. All they not critical because
         they happened during server initialisation only but
         I prefer to free memory explicitly.
  added: --no-mmap argument to 'dictd'
  ADDED: plug-in capability for DICTD.
         Using it you can develop alternative database formats,
         linguistic modules such as stemming/translator, "redirectors"
         to another dictd or on-line dictionaries such as Britannica, or
         even front-end to your favourite intra-net searchers such as
         mnogosearch and ht://Dig. Almost everything you want.

         See plugin.h and dictfmt_plugin for details

2002-09-11  Aleksey Cheusov <vle@gmx.net>

  * ChangeLog:
  ChangeLog is up-to date

2002-08-23  Aleksey Cheusov <vle@gmx.net>

  * dictfmt.c:
  added: --without-hw parameter to 'dictfmt'

  * dictfmt.c:
  added: --headword-separator parameters to 'dictfmt'.
    allows several headwords to have the same definition.
    Example: autumn%%%fall if dictfmt is run with --headword-separator %%%

  * dictd.c, dictfmt.c:
  added: locale verification both in 'dictfmt' and 'dictd'

2002-08-22  Aleksey Cheusov <vle@gmx.net>

  * dictfmt.c:
  'dictfmt' now removes ending spaces for the head words

2002-08-21  Aleksey Cheusov <vle@gmx.net>

  * dict.c:
  fixed: possible crash of 'dict' client

  * dictfmt.c:
  unnecessary /*LEAVE FIRST CHARACTER IN UPPER CASE BUT DOWNCASE THE REST*/
    has been removed from dictfmt.c

  * configure.in:
  I removed local_zlib=1 line in configure.in
    With this line
    both --with[out]-local-zlib arguments supplied to 'configure' will
    be ignored and local BUGGY zlib library will always be used.
    Now external zlib library will be used by default.

2002-08-13  Aleksey Cheusov <vle@gmx.net>

  * ChangeLog, Makefile.in:
  changed: ChangeLog

  * Makefile.in:
  added: dictfmt_index2suffix in 'install' and 'uninstall' Makefile's targets

2002-08-12  Aleksey Cheusov <vle@gmx.net>

  * dictfmt_index2suffix, utf8_ucs4.c, Makefile.in, dict.c, dictd.8, dictfmt.1, dictfmt.c:
  added: dictfmt.1, dictfmt_index2suffix, patched version of dictfmt.c
  several changes in dictd.8
  fixed: typo in utf8_ucs4.c
  added: uninstall target in Makefile.in

  Now dictfmt is a part of dictd distribution

2002-08-05  Aleksey Cheusov <vle@gmx.net>

  * ChangeLog: *** empty log message ***

  * Makefile.in:
  distclean - removes everything absent in tar.gz
  cvsclean  - removes everything absent in CVS repository

  * index.c:
  changed: substring search for UTF-8 dictionaries uses BMH but the RE.

  * libmaa/list.c, dictd.c, dictd.h, index.c:
  added: possibility to search using all characters
    but the alphanumeric and space only.
    00-database-allchars special entry in the index file is used.

  * dictd.h, index.c:
  changed: utf-8 search becomes faster

  * index.c:
  changed: UTF-8 "suffix" search uses BMH but the RE.

  * dictd.c, dictd.h, index.c, servparse.y, servscan.l, utf8_ucs4.c, utf8_ucs4.h:
  added: more efficient (probably) suffix search algorithm is implemented.
   Uses additional index file consisting of anagrams.

  * index.c:
  fixed: bug causing a lot of unnecessary comparisons

  * Makefile.in:
  changed: distclean target in Makefile.in

  * index.c:
  fixed: bug in debugging output

  * libmaa/Makefile.in, libmaa/log.c, libmaa/maa.h, Makefile.in, daemon.c, data.c, dictd.c, dictd.h, index.c, utf8_ucs4.c, utf8_ucs4.h:
  added: utf-8 functions in utf8_ucs4.c
  changed: 'distclean' target of Makefile.in
  added: argument '--test-strategy'
    it can be used for debugging.
  fixed: crash at fclose(NULL)
  fixed: crash of dictd with --ftest
  fixed: "8bit" bug in compare:index.c
  changed: comparions count in the debugging mode is calculated
    without optStart array initialization
  fixed: "8bit" bug in suffix/substring searching strategy
  changed: PRINTF and FPRINTF macroses.
    old variants cause problems with the nested if/else
  added: UTF-8 support

2002-08-02  Rik Faith <faith@dict.org>

  * libmaa/Makefile.in, libmaa/arg.c, libmaa/argtest.c, libmaa/base26.c, libmaa/base64.c, libmaa/basetest.c, libmaa/bit.c, libmaa/bittest.c, libmaa/configure.in, libmaa/debug.c, libmaa/debugtest.c, libmaa/decl.h, libmaa/error.c, libmaa/flags.c, libmaa/hash.c, libmaa/hashtest.c, libmaa/list.c, libmaa/listtest.c, libmaa/log.c, libmaa/maa.c, libmaa/maa.h, libmaa/maaP.h, libmaa/memory.c, libmaa/memtest.c, libmaa/mkrnd.c, libmaa/parse-concrete.c, libmaa/parse.c, libmaa/pr.c, libmaa/prime.c, libmaa/primetest.c, libmaa/prtest.c, libmaa/rnd.c, libmaa/set.c, libmaa/settest.c, libmaa/sl.c, libmaa/sltest.c, libmaa/source.c, libmaa/stack.c, libmaa/strdup.c, libmaa/string.c, libmaa/stringtest.c, libmaa/text.c, libmaa/timer.c, libmaa/xmalloc.c, servscan.l, ChangeLog, Makefile.in, clientparse.y, configure.in, daemon.c, data.c, dict.c, dictd.c, dictzip.c, index.c, net.c:
  Update with 1.7.1 release

2002-05-03  Rik Faith <faith@dict.org>

  * libmaa/debugtest.c, libmaa/decl.h, libmaa/error.c, libmaa/flags.c, libmaa/hash.c, libmaa/hashtest.c, libmaa/list.c, libmaa/listtest.c, libmaa/log.c, libmaa/maa.c, libmaa/maa.h, libmaa/maaP.h, libmaa/memory.c, libmaa/memtest.c, libmaa/mkrnd.c, libmaa/parse-concrete.c, libmaa/parse.c, libmaa/pr.c, libmaa/prime.c, libmaa/primetest.c, libmaa/prtest.c, libmaa/rnd.c, libmaa/set.c, libmaa/settest.c, libmaa/sl.c, libmaa/sltest.c, libmaa/source.c, libmaa/stack.c, libmaa/strdup.c, libmaa/string.c, libmaa/stringtest.c, libmaa/text.c, libmaa/timer.c, libmaa/version.c, libmaa/xmalloc.c, INSTALL, Makefile.in, clientparse.y, config.h.in, configure.in, daemon.c, data.c, dict.1, dict.c, dictd.8, dictd.c, dictd.h, dictzip.c, index.c, libmaa/Makefile.in, libmaa/acconfig.h, libmaa/arg.c, libmaa/argtest.c, libmaa/base26.c, libmaa/base64.c, libmaa/basetest.c, libmaa/bit.c, libmaa/bittest.c, libmaa/config.h.in, libmaa/configure.in, libmaa/debug.c, net.c, servscan.l, ChangeLog:
  Sync sourceforge.net repository with dictd-1.7.0 release

2001-01-12  Rik Faith <faith@dict.org>

  * Makefile.in: Bump version

2001-01-01  Bob Hilliard  <hilliard@debian.org>

  * dict.c:
  Aaaargh!  Previous update broke pager in dict.  This is fixed now.

2000-12-31  Rik Faith <faith@dict.org>

  * Makefile.in, index.c: Fix const warning
  Bump version number

  * libmaa/decl.h, libmaa/text.c, decl.h, index.c:
  Made minor changes for Solaris 5.7 compilation

2000-12-27  Bob Hilliard  <hilliard@debian.org>

  * dict.1, dict.c, dictd.8:
       dict.c - added argument to help message for -s; made all help messages go
  to stdout and error messages to stderr; disabled --html option
       dict.1 - clarified explanation of -s option (not really
  necessary, IMHO, but a bug was filed), mentioned that --html option is
  disabled.
       dictd.8 - corrected typo

2000-12-22  Rik Faith <faith@dict.org>

  * Makefile.in, codes.h, daemon.c, data.c, decl.h, dict.c, dict.h, dictP.h, dictzip.c, dictzip.h, index.c, net.c, net.h:
  Fix Debian bug #77685 (dict crashes with "-s regexp sch*".
  Update email addresses.
  Bump version number.

  * daemon.c, dict.c: Fix memory leak and remove limitation on matches.

2000-11-09  Rik Faith <faith@dict.org>

  * dict.c: Limit number of matches to print
  Because of the use of a string pool by the argification functions,
  printing too many matches can use far too much memory -- better to
  fail until we move to another string management algorithm

  * dict.c: Limit number of definitions returned to 100

2000-11-08  Rik Faith <faith@dict.org>

  * Makefile.in, dictd.c, dictd.h, servscan.l:
  Apply patches from Bob Hilliard that are in the Debian version.
  The grp.h file may not be portable and should be tested.
  Bump version number to avoid confusion.

2000-05-29  Rik Faith <faith@dict.org>

  * daemon.c: Fix MATCH

  * Makefile.in: Bump version

2000-01-27  Rik Faith <faith@dict.org>

  * Makefile.in: Man page directory fix from weed@DeepThought

1999-12-23  Julian Squires  <tek@wiw.org>

  * Makefile.in: -N no longer needed for cvs export

  * configure.in: Fix typo

  * Makefile.in, configure.in: Final fixes for 1.5.0 release.

  * INSTALL, Makefile.in: Update INSTALL for Cygwin
  Update dist target for new CVS repository

  * Makefile.in, configure.in, dict.c, dictP.h:
  Imcomplete changes for IRIX and other systems where --with-cc is needed

  * Makefile.in, configure.in, daemon.c, dictd.c, dictd.h, libmaa/log.c:
  Changes for OSF (DEC Unix) for Alpha

  * Makefile.in: Use mandir (from Tage Stabell-Kulo)
  Create man8 if it does not exist

  * net.c: Changes from Jeff Blaine and Stephen L Moshier

  * INITSCRIPT, INSTALL, README: Added credit to Jeff Blaine

  * INITSCRIPT, INSTALL, README: New documentation from Jeff Blaine

  * Makefile.in, clientscan.l, configure.in, decl.h, dict.1, dict.c, dictd.c, libmaa/hash.c, servscan.l:
  Patches from Bob and Kirk Hilliard:
  Fix error in code that causes logging to fail
  Fix stdout initialization in dict
  Fix defs for linux on sparc
  Fix hash type (for alpha?)
  Fix parse error message misalignment
  Fix some annoying compilation warnings
  Fix syntax in dictd configuration file
  Add include keyword to dictd configuration file syntax
  Add switch to specify pager (or lack thereof)
  Add documentation for pager option
  Drop root as soon as daemon starts

  Also, fix --prefix on configuration

1998-07-06  Rik Faith <faith@dict.org>

  * dictzip.1, index.c, data.c, dict.1, dictd.8, dictd.c:
  Removed Linux from man pages
  Added more UNZIP debugging code

1998-07-05  Rik Faith <faith@dict.org>

  * libmaa/timer.c, libmaa/configure.in, libmaa/Makefile.in, doc/dicf.ms, doc/Makefile.in, Makefile.in, configure.in:
  Fixed timer wrap-around between 49 and 50 days
  Fixed Makefile.in and configure.in syntax per email from Ian T Zimmerman

1998-03-01  Rik Faith <faith@dict.org>

  * dictzip.c, Makefile.in, daemon.c: Fixed typo in daemon.c
  Removed unused variables from dictzip

  * daemon.c, dictzip.c, Makefile.in: Fixed . problem
  Fixed dictzip to conform to man page

1998-02-28  Rik Faith <faith@dict.org>

  * dictd.c, Makefile.in: Update for Linux accept(2)

1998-02-22  Rik Faith <faith@dict.org>

  * ANNOUNCE: Update ANNOUNCE

  * dictd.conf: Another (more complete) example dictd.conf file

  * README, configure.in: Minor changes
  Always use local libmaa, because of recent bug fixes

  * Makefile.in, libmaa/maaP.h: Port to BSDI

1998-02-20  Rik Faith <faith@dict.org>

  * index.c, daemon.c, Makefile.in: Fixed problem with duplicates

1998-02-16  Rik Faith <faith@dict.org>

  * dictd.c, daemon.c, Makefile.in: Fixed startup bug and rate computation

  * dictd.c, dict.c: Fix race condition when counting children

  * index.c, dictd.h, dictd.c, dictd.8, dict.h, dict.c, dict.1, TODO, Makefile.in, README, ANNOUNCE:
  Added more features

1998-01-19  Rik Faith <faith@dict.org>

  * daemon.c: Updated buffer overflow behavior

  * dictd.c: Removed code for PERSISTENT servers

  * net.c, dictd.h, dictd.c, dict.h, dict.c, daemon.c, clientscan.l, clientparse.y, Makefile.in:
  Added paging feature

1998-01-16  Rik Faith <faith@dict.org>

  * decl.h, net.c, libmaa/log.c, libmaa/maaP.h, libmaa/decl.h: Changes for HPUX

  * dictd.c: Change for Solaris

  * decl.h, dictd.c, configure.in: Changes for Solaris (and some DG/UX)

1998-01-05  Rik Faith <faith@dict.org>

  * dict.c, Makefile.in: Make client deal with partially implemented servers.

  * ANNOUNCE: Add draft of announcement

  * Makefile.in: Use RFC2229 instead of building from .ms

  * doc/rfc2229.txt: Add official RFC2229

  * doc/Makefile.in, net.c, dictd.c, dict.c, README, dict.1, Makefile.in:
  Minor updates
  Try all IPs for round-robin DNS entries

1997-11-30  Rik Faith <faith@dict.org>

  * dictzip.c, dictzip.1, dictd.8, dict.c, dict.1, TODO, Makefile.in:
  Improved man pages

  * doc/rfc.ms, doc/Makefile.in, example3.conf, dictd.c, dict.c, daemon.c, configure.in:
  Work based on IETF comments

1997-08-26  Rik Faith <faith@dict.org>

  * doc/toc.ms, doc/rfc.ms, doc/Makefile.in: Working on draft -02 for IETF

1997-08-21  Rik Faith <faith@dict.org>

  * doc/rfc.ms: Describe form of extensions

1997-07-18  Rik Faith <faith@dict.org>

  * doc/security.doc, doc/rfc.ms: Minor RFC changes
  Addition of security-related comments

1997-07-12  Rik Faith <faith@dict.org>

  * dict.c: Fixed -I

  * dictd.h: Fix config file name

  * dictd.8, README, Makefile.in: Added README.  Fixed install

  * TODO, Makefile.in: Installation fixes

  * doc/rfc.ms, servparse.y, servscan.l, net.h, net.c, example.dictrc, example3.conf, dictzip.1, dictd.h, dictd.c, dictd.8, dict.html, dict.h, dict.c, dict.1, configure.in, config.h.in, clientscan.l, clientparse.y, Makefile.in:
  Added config files to client
  Added dict: parsing to client
  Options for nospelling and pipeline size
  General cleanup
  Install and dist targets

1997-07-11  Rik Faith <faith@dict.org>

  * Makefile.in: Fixed dist target

  * doc/webster.out, doc/design.tex, net.c, dictzip.c, dictd.h, dictd.c, dict.c, dict.1, Makefile.in:
  Added client options for pipesize and html
  Unified versioning
  Added dist target
  Cleaned up Makefiles
  More client bug fixes

1997-07-09  Rik Faith <faith@dict.org>

  * net.c, dictzip.c, dictd.c, dict.h, dict.c, dict.1, daemon.c:
  More work on client

1997-07-08  Rik Faith <faith@dict.org>

  * doc/rfc.ms, net.c, dictd.8, dict.h, dict.c, dict.1, daemon.c:
  Work on client

1997-07-07  Rik Faith <faith@dict.org>

  * doc/rfc.ms, example3.conf, dictd.c: Fixed proctitles on SunOS

  * dictzip.1: dictzip documentation

  * doc/rfc.ms: Final revisions

1997-06-23  Rik Faith <faith@dict.org>

  * index.c, config: Fixed BMH string matching (again)

  * index.c, dictzip.h, example.conf, dictzip.c, dictd.h, dictd.c, dictd.8, daemon.c, configure.in, Makefile.in:
  Optimized string searches, wrote man pages

  * index.c, dictd.h, dictd.c, dictd.8, daemon.c:
  Work on logging and documentation

  * doc/rfc.ms, index.c, example.conf, dictd.h, dictd.c, dictd.8:
  More work on RFC

1997-06-03  Rik Faith <faith@dict.org>

  * dictd.c: Zero memory before use

1997-06-02  Rik Faith <faith@dict.org>

  * dictd.c, daemon.c: Minor fixes

  * doc/rfc.ms, doc/Makefile.in, dict.html: More work on document

1997-05-27  Rik Faith <faith@dict.org>

  * doc/rfc.ms, doc/Makefile.in, servparse.y, servscan.l, index.c, example.site, dictd.h, example.conf, dictd.c, dict.c, daemon.c, configure.in, codes.h:
  Made daemon conform to 26May RFC draft

  * doc/Makefile.in: Makefile for doc directory

  * doc/rfc.ms, doc/design.tex: Careful edit
  Fixed -ms style formatting things.  Numbering now automatic.
  Adjusted grammar and made references to it in appropriate places.
  Added requirements section.
  Added pipelining section.
  Added comments about virtual databases.

1997-05-26  Rik Faith <faith@dict.org>

  * doc/rfc.sh: Formfee dconverter

1997-05-22  Rik Faith <faith@dict.org>

  * servscan.l, servparse.y, dictd.h, example2.conf, dictd.c, daemon.c:
  Persistent daemon clean up

1997-05-21  Rik Faith <faith@dict.org>

  * doc/rfc.ms: More work on RFC

1997-05-07  Rik Faith <faith@dict.org>

  * doc/rfc.ms: Remove mention of URL

1997-05-02  Rik Faith <faith@dict.org>

  * dictd.h, dictd.c, dict.c, daemon.c, config.h.in, configure.in, codes.h, Makefile.conf:
  Initial experiment with persistent daemons

1997-05-01  Rik Faith <faith@dict.org>

  * doc/rfc.ms: More changes from Bret

  * net.c, net.h, dictd.h, dictd.c, dict.h, dict.c, daemon.c, codes.h, Makefile.in:
  Start on client
  Fix up socket I/O

1997-04-26  Rik Faith <faith@dict.org>

  * doc/rfc.ms: Minor revisions

1997-04-22  Rik Faith <faith@dict.org>

  * doc/rfc.ms: Bret's initial additions and changes

1997-04-21  Rik Faith <faith@dict.org>

  * servscan.l, servparse.y, net.c, md5.h, md5.c, index.c, example.conf, dictd.h, dictd.c, daemon.c, Makefile.in:
  Finished initial implementation of new protocol

  * doc/rfc.ms: More changes

1997-03-31  Rik Faith <faith@dict.org>

  * doc/rfc.ms, net.h, net.c, dictd.h, dictd.c, dict.c, daemon.c, Makefile.in:
  Moving toward new protocol

1997-03-26  Rik Faith <faith@dict.org>

  * dictzip.h, dictd.h, dictd.c, daemon.c: Moving toward new protocol

  * doc/rfc.ms: RFC-like document

1997-03-23  Rik Faith <faith@dict.org>

  * net.c, example.conf, dictd.c, dictzip.c, data.c, daemon.c: Tweaking

1997-03-19  Rik Faith <faith@dict.org>

  * index.c, net.c, dictd.c: Added RESUSE for sockets
  Fixed up daemon code
  Fiddled with search algorithms a bit

1997-03-12  Rik Faith <faith@dict.org>

  * index.c, net.c, dictd.c, decl.h, daemon.c, Makefile.in:
  Made status report elapsed times for previous command
  Fixed up regular expression matching

  * net.h, net.c, dictd.h, index.c, dictd.c, Makefile.in, daemon.c:
  Added regexp matching, fixed logging

  * net.h, servparse.y, net.c, dictd.h, index.c, dictd.c, dictd.8, data.c, dictP.h, daemon.c, configure.in, Makefile.in, TODO, COPYING:
  More work

  * example.conf, index.c, dictd.h, dictzip.h, dictd.c:
  Performance enhancements

1997-03-08  Rik Faith <faith@dict.org>

  * example.conf, servscan.l, configure.in, data.c, Makefile.in:
  Finish SunOS port

  * servscan.l, fmt.c, net.c, dictd.c, dictP.h, dict.c, dict.1, decl.h, data.c, daemon.c, configure.in, config.h.in:
  Cleanup for SunOS

  * search.c, index.c, look.c, dictd.c, dictd.h, configure.in, servscan.l, wndump.c, jargdump.c, net.c, servparse.y, dictzip.c, dictzip.h, dictrc.sample, dictP.h, decl.h, dict.h, daemon.c, data.c, config.sub, Makefile.in:
  Reorganization for better packaging

  * servparse.y, dictd.c, daemon.c: Port to SunOS

1997-03-01  Rik Faith <faith@dict.org>

  * index.c, dictzip.c, dictd.c, data.c, daemon.c: Updates for SunOS

  * libmaa/version.c, dictzip.c, config, Makefile.in: Example ocnfig file

  * doc/design.tex, wndump.c, servscan.l, servparse.y, net.c, net.h, index.c, dict.h, dictd.c, data.c, daemon.c, Makefile.in:
  Initial dictd implementation

  * doc/design.tex: Config files

  * doc/design.tex: More documentation

1997-02-27  Rik Faith <faith@dict.org>

  * doc/webster.out, doc/design.tex: Add doc directory

1997-02-21  Rik Faith <faith@dict.org>

  * search.c, dict.h, dictzip.c, Makefile.in: Work on searching

1996-10-07  Rik Faith <faith@dict.org>

  * dictzip.c, Makefile.in, dict.h:
  Got random access reads on compressed file working.

  * dictzip.c: Update Id string

1996-09-26  Rik Faith <faith@dict.org>

  * wndump.c, install-sh, jargdump.c, fmt.h, dictzip.c, fmt.c, dict.h, config.sub, configure.in, config.h.in, config.guess, Makefile, Makefile.in:
  General work on formatting and use with configure.

  * wndump.c, output.c, fmt.c, fmt.h, encode.c, engine.c, dictzip.c, decode.c.save, compressdict.c, decode.c, compressdict.1, compress2.c, compress3.c, buildindex.c, COPYING.look, buildindex.1, COPYING:
  Move to version 2.0

  * output.c, engine.c, dict.h, encode.c, decode.c.save, dict.1, decode.c, compressdict.1, compressdict.c, compress3.c, buildindex.1, compress2.c, Makefile, COPYING.look:
  dict-1.1

  * output.c, look.c, dictrc.sample, engine.c, dict.h, dict.1, dict.c, buildindex.1, buildindex.c, Makefile, COPYING:
  dict-1.0

